#ifndef _H_76CF4FEBDB82801C273FF11136A8EA12_GeographicMap__H_
#define _H_76CF4FEBDB82801C273FF11136A8EA12_GeographicMap__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"
#include "geographic_msgs/msg/dds_opensplice/BoundingBox_.h"
#include "geographic_msgs/msg/dds_opensplice/WayPoint_.h"
#include "geographic_msgs/msg/dds_opensplice/MapFeature_.h"
#include "geographic_msgs/msg/dds_opensplice/KeyValue_.h"


namespace geographic_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  GeographicMap_
            {
                struct _points__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::geographic_msgs::msg::dds_::WayPoint_, struct _points__seq_uniq_ > _points__seq;
                typedef DDS_DCPSSequence_var< _points__seq > _points__seq_var;
                typedef DDS_DCPSSequence_out< _points__seq > _points__seq_out;
                struct _features__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::geographic_msgs::msg::dds_::MapFeature_, struct _features__seq_uniq_ > _features__seq;
                typedef DDS_DCPSSequence_var< _features__seq > _features__seq_var;
                typedef DDS_DCPSSequence_out< _features__seq > _features__seq_out;
                struct _props__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::geographic_msgs::msg::dds_::KeyValue_, struct _props__seq_uniq_ > _props__seq;
                typedef DDS_DCPSSequence_var< _props__seq > _props__seq_var;
                typedef DDS_DCPSSequence_out< _props__seq > _props__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::unique_identifier_msgs::msg::dds_::UUID_ id_;
                ::geographic_msgs::msg::dds_::BoundingBox_ bounds_;
                _points__seq points_;
                _features__seq features_;
                _props__seq props_;
            };

            typedef DDS_DCPSStruct_var<GeographicMap_> GeographicMap__var;
            typedef DDS_DCPSStruct_out < GeographicMap_> GeographicMap__out;

        }

    }

}

#endif /* _H_76CF4FEBDB82801C273FF11136A8EA12_GeographicMap__H_ */
