#ifndef _H_E58EC146062544AD2F1AAB0CF8903C82_RouteNetwork__H_
#define _H_E58EC146062544AD2F1AAB0CF8903C82_RouteNetwork__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"
#include "geographic_msgs/msg/dds_opensplice/BoundingBox_.h"
#include "geographic_msgs/msg/dds_opensplice/WayPoint_.h"
#include "geographic_msgs/msg/dds_opensplice/RouteSegment_.h"
#include "geographic_msgs/msg/dds_opensplice/KeyValue_.h"


namespace geographic_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  RouteNetwork_
            {
                struct _points__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::geographic_msgs::msg::dds_::WayPoint_, struct _points__seq_uniq_ > _points__seq;
                typedef DDS_DCPSSequence_var< _points__seq > _points__seq_var;
                typedef DDS_DCPSSequence_out< _points__seq > _points__seq_out;
                struct _segments__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::geographic_msgs::msg::dds_::RouteSegment_, struct _segments__seq_uniq_ > _segments__seq;
                typedef DDS_DCPSSequence_var< _segments__seq > _segments__seq_var;
                typedef DDS_DCPSSequence_out< _segments__seq > _segments__seq_out;
                struct _props__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::geographic_msgs::msg::dds_::KeyValue_, struct _props__seq_uniq_ > _props__seq;
                typedef DDS_DCPSSequence_var< _props__seq > _props__seq_var;
                typedef DDS_DCPSSequence_out< _props__seq > _props__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::unique_identifier_msgs::msg::dds_::UUID_ id_;
                ::geographic_msgs::msg::dds_::BoundingBox_ bounds_;
                _points__seq points_;
                _segments__seq segments_;
                _props__seq props_;
            };

            typedef DDS_DCPSStruct_var<RouteNetwork_> RouteNetwork__var;
            typedef DDS_DCPSStruct_out < RouteNetwork_> RouteNetwork__out;

        }

    }

}

#endif /* _H_E58EC146062544AD2F1AAB0CF8903C82_RouteNetwork__H_ */
