#ifndef _H_A00860D989F8040767F14DFFEA280290_WayPoint_DCPS_H_
#define _H_A00860D989F8040767F14DFFEA280290_WayPoint_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "WayPoint_.h"


namespace geographic_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class WayPoint_TypeSupportInterface;

            typedef WayPoint_TypeSupportInterface * WayPoint_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < WayPoint_TypeSupportInterface> WayPoint_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < WayPoint_TypeSupportInterface> WayPoint_TypeSupportInterface_out;


            class WayPoint_DataWriter;

            typedef WayPoint_DataWriter * WayPoint_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < WayPoint_DataWriter> WayPoint_DataWriter_var;
            typedef DDS_DCPSInterface_out < WayPoint_DataWriter> WayPoint_DataWriter_out;


            class WayPoint_DataReader;

            typedef WayPoint_DataReader * WayPoint_DataReader_ptr;
            typedef DDS_DCPSInterface_var < WayPoint_DataReader> WayPoint_DataReader_var;
            typedef DDS_DCPSInterface_out < WayPoint_DataReader> WayPoint_DataReader_out;


            class WayPoint_DataReaderView;

            typedef WayPoint_DataReaderView * WayPoint_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < WayPoint_DataReaderView> WayPoint_DataReaderView_var;
            typedef DDS_DCPSInterface_out < WayPoint_DataReaderView> WayPoint_DataReaderView_out;

            struct WayPoint_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < WayPoint_, struct WayPoint_Seq_uniq_> WayPoint_Seq;
            typedef DDS_DCPSSequence_var < WayPoint_Seq> WayPoint_Seq_var;
            typedef DDS_DCPSSequence_out < WayPoint_Seq> WayPoint_Seq_out;

            class  WayPoint_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef WayPoint_TypeSupportInterface_ptr _ptr_type;
                typedef WayPoint_TypeSupportInterface_var _var_type;

                static WayPoint_TypeSupportInterface_ptr _duplicate (WayPoint_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WayPoint_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static WayPoint_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WayPoint_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                WayPoint_TypeSupportInterface_ptr _this () { return this; }


            protected:
                WayPoint_TypeSupportInterface () {};
                ~WayPoint_TypeSupportInterface () {};
            private:
                WayPoint_TypeSupportInterface (const WayPoint_TypeSupportInterface &);
                WayPoint_TypeSupportInterface & operator = (const WayPoint_TypeSupportInterface &);
            };

            class  WayPoint_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef WayPoint_DataWriter_ptr _ptr_type;
                typedef WayPoint_DataWriter_var _var_type;

                static WayPoint_DataWriter_ptr _duplicate (WayPoint_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WayPoint_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static WayPoint_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WayPoint_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                WayPoint_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const WayPoint_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const WayPoint_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const WayPoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const WayPoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const WayPoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const WayPoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const WayPoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const WayPoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const WayPoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const WayPoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (WayPoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WayPoint_& instance_data) = 0;

            protected:
                WayPoint_DataWriter () {};
                ~WayPoint_DataWriter () {};
            private:
                WayPoint_DataWriter (const WayPoint_DataWriter &);
                WayPoint_DataWriter & operator = (const WayPoint_DataWriter &);
            };

            class  WayPoint_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef WayPoint_DataReader_ptr _ptr_type;
                typedef WayPoint_DataReader_var _var_type;

                static WayPoint_DataReader_ptr _duplicate (WayPoint_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WayPoint_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static WayPoint_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WayPoint_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                WayPoint_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WayPoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WayPoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WayPoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WayPoint_& instance) = 0;

            protected:
                WayPoint_DataReader () {};
                ~WayPoint_DataReader () {};
            private:
                WayPoint_DataReader (const WayPoint_DataReader &);
                WayPoint_DataReader & operator = (const WayPoint_DataReader &);
            };

            class  WayPoint_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef WayPoint_DataReaderView_ptr _ptr_type;
                typedef WayPoint_DataReaderView_var _var_type;

                static WayPoint_DataReaderView_ptr _duplicate (WayPoint_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WayPoint_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static WayPoint_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WayPoint_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                WayPoint_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WayPoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WayPoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WayPoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WayPoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WayPoint_& instance) = 0;

            protected:
                WayPoint_DataReaderView () {};
                ~WayPoint_DataReaderView () {};
            private:
                WayPoint_DataReaderView (const WayPoint_DataReaderView &);
                WayPoint_DataReaderView & operator = (const WayPoint_DataReaderView &);
            };
        }

    }

}

#endif
