#ifndef _H_E4FD0772C592C96074956D4AE4BE22A3_GetGeoPath_DCPS_H_
#define _H_E4FD0772C592C96074956D4AE4BE22A3_GetGeoPath_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetGeoPath_.h"


namespace geographic_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetGeoPath_Request_TypeSupportInterface;

            typedef GetGeoPath_Request_TypeSupportInterface * GetGeoPath_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetGeoPath_Request_TypeSupportInterface> GetGeoPath_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetGeoPath_Request_TypeSupportInterface> GetGeoPath_Request_TypeSupportInterface_out;


            class GetGeoPath_Request_DataWriter;

            typedef GetGeoPath_Request_DataWriter * GetGeoPath_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetGeoPath_Request_DataWriter> GetGeoPath_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetGeoPath_Request_DataWriter> GetGeoPath_Request_DataWriter_out;


            class GetGeoPath_Request_DataReader;

            typedef GetGeoPath_Request_DataReader * GetGeoPath_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetGeoPath_Request_DataReader> GetGeoPath_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetGeoPath_Request_DataReader> GetGeoPath_Request_DataReader_out;


            class GetGeoPath_Request_DataReaderView;

            typedef GetGeoPath_Request_DataReaderView * GetGeoPath_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetGeoPath_Request_DataReaderView> GetGeoPath_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetGeoPath_Request_DataReaderView> GetGeoPath_Request_DataReaderView_out;

            struct GetGeoPath_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetGeoPath_Request_, struct GetGeoPath_Request_Seq_uniq_> GetGeoPath_Request_Seq;
            typedef DDS_DCPSSequence_var < GetGeoPath_Request_Seq> GetGeoPath_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetGeoPath_Request_Seq> GetGeoPath_Request_Seq_out;

            class  GetGeoPath_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetGeoPath_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetGeoPath_Request_TypeSupportInterface_var _var_type;

                static GetGeoPath_Request_TypeSupportInterface_ptr _duplicate (GetGeoPath_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeoPath_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetGeoPath_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeoPath_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeoPath_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetGeoPath_Request_TypeSupportInterface () {};
                ~GetGeoPath_Request_TypeSupportInterface () {};
            private:
                GetGeoPath_Request_TypeSupportInterface (const GetGeoPath_Request_TypeSupportInterface &);
                GetGeoPath_Request_TypeSupportInterface & operator = (const GetGeoPath_Request_TypeSupportInterface &);
            };

            class  GetGeoPath_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetGeoPath_Request_DataWriter_ptr _ptr_type;
                typedef GetGeoPath_Request_DataWriter_var _var_type;

                static GetGeoPath_Request_DataWriter_ptr _duplicate (GetGeoPath_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeoPath_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetGeoPath_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeoPath_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeoPath_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetGeoPath_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetGeoPath_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetGeoPath_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetGeoPath_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetGeoPath_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetGeoPath_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetGeoPath_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetGeoPath_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetGeoPath_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetGeoPath_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetGeoPath_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetGeoPath_Request_& instance_data) = 0;

            protected:
                GetGeoPath_Request_DataWriter () {};
                ~GetGeoPath_Request_DataWriter () {};
            private:
                GetGeoPath_Request_DataWriter (const GetGeoPath_Request_DataWriter &);
                GetGeoPath_Request_DataWriter & operator = (const GetGeoPath_Request_DataWriter &);
            };

            class  GetGeoPath_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetGeoPath_Request_DataReader_ptr _ptr_type;
                typedef GetGeoPath_Request_DataReader_var _var_type;

                static GetGeoPath_Request_DataReader_ptr _duplicate (GetGeoPath_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeoPath_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetGeoPath_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeoPath_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeoPath_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetGeoPath_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetGeoPath_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetGeoPath_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetGeoPath_Request_& instance) = 0;

            protected:
                GetGeoPath_Request_DataReader () {};
                ~GetGeoPath_Request_DataReader () {};
            private:
                GetGeoPath_Request_DataReader (const GetGeoPath_Request_DataReader &);
                GetGeoPath_Request_DataReader & operator = (const GetGeoPath_Request_DataReader &);
            };

            class  GetGeoPath_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetGeoPath_Request_DataReaderView_ptr _ptr_type;
                typedef GetGeoPath_Request_DataReaderView_var _var_type;

                static GetGeoPath_Request_DataReaderView_ptr _duplicate (GetGeoPath_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeoPath_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetGeoPath_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeoPath_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeoPath_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetGeoPath_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetGeoPath_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetGeoPath_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetGeoPath_Request_& instance) = 0;

            protected:
                GetGeoPath_Request_DataReaderView () {};
                ~GetGeoPath_Request_DataReaderView () {};
            private:
                GetGeoPath_Request_DataReaderView (const GetGeoPath_Request_DataReaderView &);
                GetGeoPath_Request_DataReaderView & operator = (const GetGeoPath_Request_DataReaderView &);
            };
            class GetGeoPath_Response_TypeSupportInterface;

            typedef GetGeoPath_Response_TypeSupportInterface * GetGeoPath_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetGeoPath_Response_TypeSupportInterface> GetGeoPath_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetGeoPath_Response_TypeSupportInterface> GetGeoPath_Response_TypeSupportInterface_out;


            class GetGeoPath_Response_DataWriter;

            typedef GetGeoPath_Response_DataWriter * GetGeoPath_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetGeoPath_Response_DataWriter> GetGeoPath_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetGeoPath_Response_DataWriter> GetGeoPath_Response_DataWriter_out;


            class GetGeoPath_Response_DataReader;

            typedef GetGeoPath_Response_DataReader * GetGeoPath_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetGeoPath_Response_DataReader> GetGeoPath_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetGeoPath_Response_DataReader> GetGeoPath_Response_DataReader_out;


            class GetGeoPath_Response_DataReaderView;

            typedef GetGeoPath_Response_DataReaderView * GetGeoPath_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetGeoPath_Response_DataReaderView> GetGeoPath_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetGeoPath_Response_DataReaderView> GetGeoPath_Response_DataReaderView_out;

            struct GetGeoPath_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetGeoPath_Response_, struct GetGeoPath_Response_Seq_uniq_> GetGeoPath_Response_Seq;
            typedef DDS_DCPSSequence_var < GetGeoPath_Response_Seq> GetGeoPath_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetGeoPath_Response_Seq> GetGeoPath_Response_Seq_out;

            class  GetGeoPath_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetGeoPath_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetGeoPath_Response_TypeSupportInterface_var _var_type;

                static GetGeoPath_Response_TypeSupportInterface_ptr _duplicate (GetGeoPath_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeoPath_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetGeoPath_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeoPath_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeoPath_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetGeoPath_Response_TypeSupportInterface () {};
                ~GetGeoPath_Response_TypeSupportInterface () {};
            private:
                GetGeoPath_Response_TypeSupportInterface (const GetGeoPath_Response_TypeSupportInterface &);
                GetGeoPath_Response_TypeSupportInterface & operator = (const GetGeoPath_Response_TypeSupportInterface &);
            };

            class  GetGeoPath_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetGeoPath_Response_DataWriter_ptr _ptr_type;
                typedef GetGeoPath_Response_DataWriter_var _var_type;

                static GetGeoPath_Response_DataWriter_ptr _duplicate (GetGeoPath_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeoPath_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetGeoPath_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeoPath_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeoPath_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetGeoPath_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetGeoPath_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetGeoPath_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetGeoPath_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetGeoPath_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetGeoPath_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetGeoPath_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetGeoPath_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetGeoPath_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetGeoPath_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetGeoPath_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetGeoPath_Response_& instance_data) = 0;

            protected:
                GetGeoPath_Response_DataWriter () {};
                ~GetGeoPath_Response_DataWriter () {};
            private:
                GetGeoPath_Response_DataWriter (const GetGeoPath_Response_DataWriter &);
                GetGeoPath_Response_DataWriter & operator = (const GetGeoPath_Response_DataWriter &);
            };

            class  GetGeoPath_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetGeoPath_Response_DataReader_ptr _ptr_type;
                typedef GetGeoPath_Response_DataReader_var _var_type;

                static GetGeoPath_Response_DataReader_ptr _duplicate (GetGeoPath_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeoPath_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetGeoPath_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeoPath_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeoPath_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetGeoPath_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetGeoPath_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetGeoPath_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetGeoPath_Response_& instance) = 0;

            protected:
                GetGeoPath_Response_DataReader () {};
                ~GetGeoPath_Response_DataReader () {};
            private:
                GetGeoPath_Response_DataReader (const GetGeoPath_Response_DataReader &);
                GetGeoPath_Response_DataReader & operator = (const GetGeoPath_Response_DataReader &);
            };

            class  GetGeoPath_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetGeoPath_Response_DataReaderView_ptr _ptr_type;
                typedef GetGeoPath_Response_DataReaderView_var _var_type;

                static GetGeoPath_Response_DataReaderView_ptr _duplicate (GetGeoPath_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeoPath_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetGeoPath_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeoPath_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeoPath_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetGeoPath_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetGeoPath_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetGeoPath_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetGeoPath_Response_& instance) = 0;

            protected:
                GetGeoPath_Response_DataReaderView () {};
                ~GetGeoPath_Response_DataReaderView () {};
            private:
                GetGeoPath_Response_DataReaderView (const GetGeoPath_Response_DataReaderView &);
                GetGeoPath_Response_DataReaderView & operator = (const GetGeoPath_Response_DataReaderView &);
            };
            class Sample_GetGeoPath_Request_TypeSupportInterface;

            typedef Sample_GetGeoPath_Request_TypeSupportInterface * Sample_GetGeoPath_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeoPath_Request_TypeSupportInterface> Sample_GetGeoPath_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeoPath_Request_TypeSupportInterface> Sample_GetGeoPath_Request_TypeSupportInterface_out;


            class Sample_GetGeoPath_Request_DataWriter;

            typedef Sample_GetGeoPath_Request_DataWriter * Sample_GetGeoPath_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeoPath_Request_DataWriter> Sample_GetGeoPath_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeoPath_Request_DataWriter> Sample_GetGeoPath_Request_DataWriter_out;


            class Sample_GetGeoPath_Request_DataReader;

            typedef Sample_GetGeoPath_Request_DataReader * Sample_GetGeoPath_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeoPath_Request_DataReader> Sample_GetGeoPath_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeoPath_Request_DataReader> Sample_GetGeoPath_Request_DataReader_out;


            class Sample_GetGeoPath_Request_DataReaderView;

            typedef Sample_GetGeoPath_Request_DataReaderView * Sample_GetGeoPath_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeoPath_Request_DataReaderView> Sample_GetGeoPath_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeoPath_Request_DataReaderView> Sample_GetGeoPath_Request_DataReaderView_out;

            struct Sample_GetGeoPath_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetGeoPath_Request_, struct Sample_GetGeoPath_Request_Seq_uniq_> Sample_GetGeoPath_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetGeoPath_Request_Seq> Sample_GetGeoPath_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetGeoPath_Request_Seq> Sample_GetGeoPath_Request_Seq_out;

            class  Sample_GetGeoPath_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetGeoPath_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetGeoPath_Request_TypeSupportInterface_var _var_type;

                static Sample_GetGeoPath_Request_TypeSupportInterface_ptr _duplicate (Sample_GetGeoPath_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeoPath_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeoPath_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetGeoPath_Request_TypeSupportInterface () {};
                ~Sample_GetGeoPath_Request_TypeSupportInterface () {};
            private:
                Sample_GetGeoPath_Request_TypeSupportInterface (const Sample_GetGeoPath_Request_TypeSupportInterface &);
                Sample_GetGeoPath_Request_TypeSupportInterface & operator = (const Sample_GetGeoPath_Request_TypeSupportInterface &);
            };

            class  Sample_GetGeoPath_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetGeoPath_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetGeoPath_Request_DataWriter_var _var_type;

                static Sample_GetGeoPath_Request_DataWriter_ptr _duplicate (Sample_GetGeoPath_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeoPath_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeoPath_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetGeoPath_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetGeoPath_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetGeoPath_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetGeoPath_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetGeoPath_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetGeoPath_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetGeoPath_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetGeoPath_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetGeoPath_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetGeoPath_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetGeoPath_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetGeoPath_Request_& instance_data) = 0;

            protected:
                Sample_GetGeoPath_Request_DataWriter () {};
                ~Sample_GetGeoPath_Request_DataWriter () {};
            private:
                Sample_GetGeoPath_Request_DataWriter (const Sample_GetGeoPath_Request_DataWriter &);
                Sample_GetGeoPath_Request_DataWriter & operator = (const Sample_GetGeoPath_Request_DataWriter &);
            };

            class  Sample_GetGeoPath_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetGeoPath_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetGeoPath_Request_DataReader_var _var_type;

                static Sample_GetGeoPath_Request_DataReader_ptr _duplicate (Sample_GetGeoPath_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeoPath_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeoPath_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetGeoPath_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetGeoPath_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetGeoPath_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetGeoPath_Request_& instance) = 0;

            protected:
                Sample_GetGeoPath_Request_DataReader () {};
                ~Sample_GetGeoPath_Request_DataReader () {};
            private:
                Sample_GetGeoPath_Request_DataReader (const Sample_GetGeoPath_Request_DataReader &);
                Sample_GetGeoPath_Request_DataReader & operator = (const Sample_GetGeoPath_Request_DataReader &);
            };

            class  Sample_GetGeoPath_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetGeoPath_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetGeoPath_Request_DataReaderView_var _var_type;

                static Sample_GetGeoPath_Request_DataReaderView_ptr _duplicate (Sample_GetGeoPath_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeoPath_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeoPath_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetGeoPath_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetGeoPath_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetGeoPath_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetGeoPath_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetGeoPath_Request_& instance) = 0;

            protected:
                Sample_GetGeoPath_Request_DataReaderView () {};
                ~Sample_GetGeoPath_Request_DataReaderView () {};
            private:
                Sample_GetGeoPath_Request_DataReaderView (const Sample_GetGeoPath_Request_DataReaderView &);
                Sample_GetGeoPath_Request_DataReaderView & operator = (const Sample_GetGeoPath_Request_DataReaderView &);
            };
            class Sample_GetGeoPath_Response_TypeSupportInterface;

            typedef Sample_GetGeoPath_Response_TypeSupportInterface * Sample_GetGeoPath_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeoPath_Response_TypeSupportInterface> Sample_GetGeoPath_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeoPath_Response_TypeSupportInterface> Sample_GetGeoPath_Response_TypeSupportInterface_out;


            class Sample_GetGeoPath_Response_DataWriter;

            typedef Sample_GetGeoPath_Response_DataWriter * Sample_GetGeoPath_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeoPath_Response_DataWriter> Sample_GetGeoPath_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeoPath_Response_DataWriter> Sample_GetGeoPath_Response_DataWriter_out;


            class Sample_GetGeoPath_Response_DataReader;

            typedef Sample_GetGeoPath_Response_DataReader * Sample_GetGeoPath_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeoPath_Response_DataReader> Sample_GetGeoPath_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeoPath_Response_DataReader> Sample_GetGeoPath_Response_DataReader_out;


            class Sample_GetGeoPath_Response_DataReaderView;

            typedef Sample_GetGeoPath_Response_DataReaderView * Sample_GetGeoPath_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeoPath_Response_DataReaderView> Sample_GetGeoPath_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeoPath_Response_DataReaderView> Sample_GetGeoPath_Response_DataReaderView_out;

            struct Sample_GetGeoPath_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetGeoPath_Response_, struct Sample_GetGeoPath_Response_Seq_uniq_> Sample_GetGeoPath_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetGeoPath_Response_Seq> Sample_GetGeoPath_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetGeoPath_Response_Seq> Sample_GetGeoPath_Response_Seq_out;

            class  Sample_GetGeoPath_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetGeoPath_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetGeoPath_Response_TypeSupportInterface_var _var_type;

                static Sample_GetGeoPath_Response_TypeSupportInterface_ptr _duplicate (Sample_GetGeoPath_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeoPath_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeoPath_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetGeoPath_Response_TypeSupportInterface () {};
                ~Sample_GetGeoPath_Response_TypeSupportInterface () {};
            private:
                Sample_GetGeoPath_Response_TypeSupportInterface (const Sample_GetGeoPath_Response_TypeSupportInterface &);
                Sample_GetGeoPath_Response_TypeSupportInterface & operator = (const Sample_GetGeoPath_Response_TypeSupportInterface &);
            };

            class  Sample_GetGeoPath_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetGeoPath_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetGeoPath_Response_DataWriter_var _var_type;

                static Sample_GetGeoPath_Response_DataWriter_ptr _duplicate (Sample_GetGeoPath_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeoPath_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeoPath_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetGeoPath_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetGeoPath_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetGeoPath_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetGeoPath_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetGeoPath_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetGeoPath_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetGeoPath_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetGeoPath_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetGeoPath_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetGeoPath_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetGeoPath_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetGeoPath_Response_& instance_data) = 0;

            protected:
                Sample_GetGeoPath_Response_DataWriter () {};
                ~Sample_GetGeoPath_Response_DataWriter () {};
            private:
                Sample_GetGeoPath_Response_DataWriter (const Sample_GetGeoPath_Response_DataWriter &);
                Sample_GetGeoPath_Response_DataWriter & operator = (const Sample_GetGeoPath_Response_DataWriter &);
            };

            class  Sample_GetGeoPath_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetGeoPath_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetGeoPath_Response_DataReader_var _var_type;

                static Sample_GetGeoPath_Response_DataReader_ptr _duplicate (Sample_GetGeoPath_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeoPath_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeoPath_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetGeoPath_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetGeoPath_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetGeoPath_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetGeoPath_Response_& instance) = 0;

            protected:
                Sample_GetGeoPath_Response_DataReader () {};
                ~Sample_GetGeoPath_Response_DataReader () {};
            private:
                Sample_GetGeoPath_Response_DataReader (const Sample_GetGeoPath_Response_DataReader &);
                Sample_GetGeoPath_Response_DataReader & operator = (const Sample_GetGeoPath_Response_DataReader &);
            };

            class  Sample_GetGeoPath_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetGeoPath_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetGeoPath_Response_DataReaderView_var _var_type;

                static Sample_GetGeoPath_Response_DataReaderView_ptr _duplicate (Sample_GetGeoPath_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeoPath_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeoPath_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeoPath_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetGeoPath_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetGeoPath_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetGeoPath_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetGeoPath_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetGeoPath_Response_& instance) = 0;

            protected:
                Sample_GetGeoPath_Response_DataReaderView () {};
                ~Sample_GetGeoPath_Response_DataReaderView () {};
            private:
                Sample_GetGeoPath_Response_DataReaderView (const Sample_GetGeoPath_Response_DataReaderView &);
                Sample_GetGeoPath_Response_DataReaderView & operator = (const Sample_GetGeoPath_Response_DataReaderView &);
            };
        }

    }

}

#endif
