#ifndef _H_6418FE42C19696DF9EF2E2B0C211F62F_UpdateGeographicMap__H_
#define _H_6418FE42C19696DF9EF2E2B0C211F62F_UpdateGeographicMap__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geographic_msgs/msg/dds_opensplice/GeographicMapChanges_.h"


namespace geographic_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  UpdateGeographicMap_Request_
            {
                ::geographic_msgs::msg::dds_::GeographicMapChanges_ updates_;
            };

            typedef DDS_DCPSStruct_var<UpdateGeographicMap_Request_> UpdateGeographicMap_Request__var;
            typedef DDS_DCPSStruct_out < UpdateGeographicMap_Request_> UpdateGeographicMap_Request__out;

            struct  UpdateGeographicMap_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr status_;
            };

            typedef DDS_DCPSStruct_var<UpdateGeographicMap_Response_> UpdateGeographicMap_Response__var;
            typedef DDS_DCPSStruct_out < UpdateGeographicMap_Response_> UpdateGeographicMap_Response__out;

            struct  Sample_UpdateGeographicMap_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::geographic_msgs::srv::dds_::UpdateGeographicMap_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_UpdateGeographicMap_Request_> Sample_UpdateGeographicMap_Request__var;
            typedef DDS_DCPSStruct_out < Sample_UpdateGeographicMap_Request_> Sample_UpdateGeographicMap_Request__out;

            struct  Sample_UpdateGeographicMap_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::geographic_msgs::srv::dds_::UpdateGeographicMap_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_UpdateGeographicMap_Response_> Sample_UpdateGeographicMap_Response__var;
            typedef DDS_DCPSStruct_out < Sample_UpdateGeographicMap_Response_> Sample_UpdateGeographicMap_Response__out;

        }

    }

}

#endif /* _H_6418FE42C19696DF9EF2E2B0C211F62F_UpdateGeographicMap__H_ */
