#ifndef _H_24A05261B321F128EC52AD1FFEDDF2DD_GeoPoseStamped_DCPS_H_
#define _H_24A05261B321F128EC52AD1FFEDDF2DD_GeoPoseStamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GeoPoseStamped_.h"


namespace geographic_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GeoPoseStamped_TypeSupportInterface;

            typedef GeoPoseStamped_TypeSupportInterface * GeoPoseStamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GeoPoseStamped_TypeSupportInterface> GeoPoseStamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GeoPoseStamped_TypeSupportInterface> GeoPoseStamped_TypeSupportInterface_out;


            class GeoPoseStamped_DataWriter;

            typedef GeoPoseStamped_DataWriter * GeoPoseStamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GeoPoseStamped_DataWriter> GeoPoseStamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < GeoPoseStamped_DataWriter> GeoPoseStamped_DataWriter_out;


            class GeoPoseStamped_DataReader;

            typedef GeoPoseStamped_DataReader * GeoPoseStamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GeoPoseStamped_DataReader> GeoPoseStamped_DataReader_var;
            typedef DDS_DCPSInterface_out < GeoPoseStamped_DataReader> GeoPoseStamped_DataReader_out;


            class GeoPoseStamped_DataReaderView;

            typedef GeoPoseStamped_DataReaderView * GeoPoseStamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GeoPoseStamped_DataReaderView> GeoPoseStamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GeoPoseStamped_DataReaderView> GeoPoseStamped_DataReaderView_out;

            struct GeoPoseStamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GeoPoseStamped_, struct GeoPoseStamped_Seq_uniq_> GeoPoseStamped_Seq;
            typedef DDS_DCPSSequence_var < GeoPoseStamped_Seq> GeoPoseStamped_Seq_var;
            typedef DDS_DCPSSequence_out < GeoPoseStamped_Seq> GeoPoseStamped_Seq_out;

            class  GeoPoseStamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GeoPoseStamped_TypeSupportInterface_ptr _ptr_type;
                typedef GeoPoseStamped_TypeSupportInterface_var _var_type;

                static GeoPoseStamped_TypeSupportInterface_ptr _duplicate (GeoPoseStamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeoPoseStamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GeoPoseStamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeoPoseStamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GeoPoseStamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GeoPoseStamped_TypeSupportInterface () {};
                ~GeoPoseStamped_TypeSupportInterface () {};
            private:
                GeoPoseStamped_TypeSupportInterface (const GeoPoseStamped_TypeSupportInterface &);
                GeoPoseStamped_TypeSupportInterface & operator = (const GeoPoseStamped_TypeSupportInterface &);
            };

            class  GeoPoseStamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GeoPoseStamped_DataWriter_ptr _ptr_type;
                typedef GeoPoseStamped_DataWriter_var _var_type;

                static GeoPoseStamped_DataWriter_ptr _duplicate (GeoPoseStamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeoPoseStamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GeoPoseStamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeoPoseStamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GeoPoseStamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GeoPoseStamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GeoPoseStamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GeoPoseStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GeoPoseStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GeoPoseStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GeoPoseStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GeoPoseStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GeoPoseStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GeoPoseStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GeoPoseStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GeoPoseStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GeoPoseStamped_& instance_data) = 0;

            protected:
                GeoPoseStamped_DataWriter () {};
                ~GeoPoseStamped_DataWriter () {};
            private:
                GeoPoseStamped_DataWriter (const GeoPoseStamped_DataWriter &);
                GeoPoseStamped_DataWriter & operator = (const GeoPoseStamped_DataWriter &);
            };

            class  GeoPoseStamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GeoPoseStamped_DataReader_ptr _ptr_type;
                typedef GeoPoseStamped_DataReader_var _var_type;

                static GeoPoseStamped_DataReader_ptr _duplicate (GeoPoseStamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeoPoseStamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GeoPoseStamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeoPoseStamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GeoPoseStamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GeoPoseStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GeoPoseStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GeoPoseStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GeoPoseStamped_& instance) = 0;

            protected:
                GeoPoseStamped_DataReader () {};
                ~GeoPoseStamped_DataReader () {};
            private:
                GeoPoseStamped_DataReader (const GeoPoseStamped_DataReader &);
                GeoPoseStamped_DataReader & operator = (const GeoPoseStamped_DataReader &);
            };

            class  GeoPoseStamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GeoPoseStamped_DataReaderView_ptr _ptr_type;
                typedef GeoPoseStamped_DataReaderView_var _var_type;

                static GeoPoseStamped_DataReaderView_ptr _duplicate (GeoPoseStamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeoPoseStamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GeoPoseStamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeoPoseStamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GeoPoseStamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GeoPoseStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GeoPoseStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GeoPoseStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GeoPoseStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GeoPoseStamped_& instance) = 0;

            protected:
                GeoPoseStamped_DataReaderView () {};
                ~GeoPoseStamped_DataReaderView () {};
            private:
                GeoPoseStamped_DataReaderView (const GeoPoseStamped_DataReaderView &);
                GeoPoseStamped_DataReaderView & operator = (const GeoPoseStamped_DataReaderView &);
            };
        }

    }

}

#endif
