#ifndef _H_DBA225A20A9A835CBEEDBC20BC7D9104_GeographicMapChanges_DCPS_H_
#define _H_DBA225A20A9A835CBEEDBC20BC7D9104_GeographicMapChanges_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GeographicMapChanges_.h"


namespace geographic_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GeographicMapChanges_TypeSupportInterface;

            typedef GeographicMapChanges_TypeSupportInterface * GeographicMapChanges_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GeographicMapChanges_TypeSupportInterface> GeographicMapChanges_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GeographicMapChanges_TypeSupportInterface> GeographicMapChanges_TypeSupportInterface_out;


            class GeographicMapChanges_DataWriter;

            typedef GeographicMapChanges_DataWriter * GeographicMapChanges_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GeographicMapChanges_DataWriter> GeographicMapChanges_DataWriter_var;
            typedef DDS_DCPSInterface_out < GeographicMapChanges_DataWriter> GeographicMapChanges_DataWriter_out;


            class GeographicMapChanges_DataReader;

            typedef GeographicMapChanges_DataReader * GeographicMapChanges_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GeographicMapChanges_DataReader> GeographicMapChanges_DataReader_var;
            typedef DDS_DCPSInterface_out < GeographicMapChanges_DataReader> GeographicMapChanges_DataReader_out;


            class GeographicMapChanges_DataReaderView;

            typedef GeographicMapChanges_DataReaderView * GeographicMapChanges_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GeographicMapChanges_DataReaderView> GeographicMapChanges_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GeographicMapChanges_DataReaderView> GeographicMapChanges_DataReaderView_out;

            struct GeographicMapChanges_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GeographicMapChanges_, struct GeographicMapChanges_Seq_uniq_> GeographicMapChanges_Seq;
            typedef DDS_DCPSSequence_var < GeographicMapChanges_Seq> GeographicMapChanges_Seq_var;
            typedef DDS_DCPSSequence_out < GeographicMapChanges_Seq> GeographicMapChanges_Seq_out;

            class  GeographicMapChanges_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GeographicMapChanges_TypeSupportInterface_ptr _ptr_type;
                typedef GeographicMapChanges_TypeSupportInterface_var _var_type;

                static GeographicMapChanges_TypeSupportInterface_ptr _duplicate (GeographicMapChanges_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeographicMapChanges_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GeographicMapChanges_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeographicMapChanges_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GeographicMapChanges_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GeographicMapChanges_TypeSupportInterface () {};
                ~GeographicMapChanges_TypeSupportInterface () {};
            private:
                GeographicMapChanges_TypeSupportInterface (const GeographicMapChanges_TypeSupportInterface &);
                GeographicMapChanges_TypeSupportInterface & operator = (const GeographicMapChanges_TypeSupportInterface &);
            };

            class  GeographicMapChanges_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GeographicMapChanges_DataWriter_ptr _ptr_type;
                typedef GeographicMapChanges_DataWriter_var _var_type;

                static GeographicMapChanges_DataWriter_ptr _duplicate (GeographicMapChanges_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeographicMapChanges_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GeographicMapChanges_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeographicMapChanges_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GeographicMapChanges_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GeographicMapChanges_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GeographicMapChanges_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GeographicMapChanges_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GeographicMapChanges_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GeographicMapChanges_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GeographicMapChanges_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GeographicMapChanges_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GeographicMapChanges_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GeographicMapChanges_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GeographicMapChanges_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GeographicMapChanges_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GeographicMapChanges_& instance_data) = 0;

            protected:
                GeographicMapChanges_DataWriter () {};
                ~GeographicMapChanges_DataWriter () {};
            private:
                GeographicMapChanges_DataWriter (const GeographicMapChanges_DataWriter &);
                GeographicMapChanges_DataWriter & operator = (const GeographicMapChanges_DataWriter &);
            };

            class  GeographicMapChanges_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GeographicMapChanges_DataReader_ptr _ptr_type;
                typedef GeographicMapChanges_DataReader_var _var_type;

                static GeographicMapChanges_DataReader_ptr _duplicate (GeographicMapChanges_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeographicMapChanges_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GeographicMapChanges_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeographicMapChanges_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GeographicMapChanges_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GeographicMapChanges_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GeographicMapChanges_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GeographicMapChanges_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GeographicMapChanges_& instance) = 0;

            protected:
                GeographicMapChanges_DataReader () {};
                ~GeographicMapChanges_DataReader () {};
            private:
                GeographicMapChanges_DataReader (const GeographicMapChanges_DataReader &);
                GeographicMapChanges_DataReader & operator = (const GeographicMapChanges_DataReader &);
            };

            class  GeographicMapChanges_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GeographicMapChanges_DataReaderView_ptr _ptr_type;
                typedef GeographicMapChanges_DataReaderView_var _var_type;

                static GeographicMapChanges_DataReaderView_ptr _duplicate (GeographicMapChanges_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeographicMapChanges_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GeographicMapChanges_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeographicMapChanges_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GeographicMapChanges_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GeographicMapChanges_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GeographicMapChanges_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GeographicMapChanges_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GeographicMapChanges_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GeographicMapChanges_& instance) = 0;

            protected:
                GeographicMapChanges_DataReaderView () {};
                ~GeographicMapChanges_DataReaderView () {};
            private:
                GeographicMapChanges_DataReaderView (const GeographicMapChanges_DataReaderView &);
                GeographicMapChanges_DataReaderView & operator = (const GeographicMapChanges_DataReaderView &);
            };
        }

    }

}

#endif
