#ifndef _H_76CF4FEBDB82801C273FF11136A8EA12_GeographicMap_DCPS_H_
#define _H_76CF4FEBDB82801C273FF11136A8EA12_GeographicMap_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GeographicMap_.h"


namespace geographic_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GeographicMap_TypeSupportInterface;

            typedef GeographicMap_TypeSupportInterface * GeographicMap_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GeographicMap_TypeSupportInterface> GeographicMap_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GeographicMap_TypeSupportInterface> GeographicMap_TypeSupportInterface_out;


            class GeographicMap_DataWriter;

            typedef GeographicMap_DataWriter * GeographicMap_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GeographicMap_DataWriter> GeographicMap_DataWriter_var;
            typedef DDS_DCPSInterface_out < GeographicMap_DataWriter> GeographicMap_DataWriter_out;


            class GeographicMap_DataReader;

            typedef GeographicMap_DataReader * GeographicMap_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GeographicMap_DataReader> GeographicMap_DataReader_var;
            typedef DDS_DCPSInterface_out < GeographicMap_DataReader> GeographicMap_DataReader_out;


            class GeographicMap_DataReaderView;

            typedef GeographicMap_DataReaderView * GeographicMap_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GeographicMap_DataReaderView> GeographicMap_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GeographicMap_DataReaderView> GeographicMap_DataReaderView_out;

            struct GeographicMap_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GeographicMap_, struct GeographicMap_Seq_uniq_> GeographicMap_Seq;
            typedef DDS_DCPSSequence_var < GeographicMap_Seq> GeographicMap_Seq_var;
            typedef DDS_DCPSSequence_out < GeographicMap_Seq> GeographicMap_Seq_out;

            class  GeographicMap_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GeographicMap_TypeSupportInterface_ptr _ptr_type;
                typedef GeographicMap_TypeSupportInterface_var _var_type;

                static GeographicMap_TypeSupportInterface_ptr _duplicate (GeographicMap_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeographicMap_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GeographicMap_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeographicMap_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GeographicMap_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GeographicMap_TypeSupportInterface () {};
                ~GeographicMap_TypeSupportInterface () {};
            private:
                GeographicMap_TypeSupportInterface (const GeographicMap_TypeSupportInterface &);
                GeographicMap_TypeSupportInterface & operator = (const GeographicMap_TypeSupportInterface &);
            };

            class  GeographicMap_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GeographicMap_DataWriter_ptr _ptr_type;
                typedef GeographicMap_DataWriter_var _var_type;

                static GeographicMap_DataWriter_ptr _duplicate (GeographicMap_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeographicMap_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GeographicMap_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeographicMap_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GeographicMap_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GeographicMap_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GeographicMap_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GeographicMap_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GeographicMap_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GeographicMap_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GeographicMap_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GeographicMap_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GeographicMap_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GeographicMap_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GeographicMap_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GeographicMap_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GeographicMap_& instance_data) = 0;

            protected:
                GeographicMap_DataWriter () {};
                ~GeographicMap_DataWriter () {};
            private:
                GeographicMap_DataWriter (const GeographicMap_DataWriter &);
                GeographicMap_DataWriter & operator = (const GeographicMap_DataWriter &);
            };

            class  GeographicMap_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GeographicMap_DataReader_ptr _ptr_type;
                typedef GeographicMap_DataReader_var _var_type;

                static GeographicMap_DataReader_ptr _duplicate (GeographicMap_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeographicMap_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GeographicMap_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeographicMap_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GeographicMap_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GeographicMap_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GeographicMap_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GeographicMap_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GeographicMap_& instance) = 0;

            protected:
                GeographicMap_DataReader () {};
                ~GeographicMap_DataReader () {};
            private:
                GeographicMap_DataReader (const GeographicMap_DataReader &);
                GeographicMap_DataReader & operator = (const GeographicMap_DataReader &);
            };

            class  GeographicMap_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GeographicMap_DataReaderView_ptr _ptr_type;
                typedef GeographicMap_DataReaderView_var _var_type;

                static GeographicMap_DataReaderView_ptr _duplicate (GeographicMap_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeographicMap_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GeographicMap_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeographicMap_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GeographicMap_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GeographicMap_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GeographicMap_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GeographicMap_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GeographicMap_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GeographicMap_& instance) = 0;

            protected:
                GeographicMap_DataReaderView () {};
                ~GeographicMap_DataReaderView () {};
            private:
                GeographicMap_DataReaderView (const GeographicMap_DataReaderView &);
                GeographicMap_DataReaderView & operator = (const GeographicMap_DataReaderView &);
            };
        }

    }

}

#endif
