#ifndef _H_6F637CAAE53569769B39DA354F899B19_RoutePath__H_
#define _H_6F637CAAE53569769B39DA354F899B19_RoutePath__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"
#include "geographic_msgs/msg/dds_opensplice/KeyValue_.h"


namespace geographic_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  RoutePath_
            {
                struct _segments__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::unique_identifier_msgs::msg::dds_::UUID_, struct _segments__seq_uniq_ > _segments__seq;
                typedef DDS_DCPSSequence_var< _segments__seq > _segments__seq_var;
                typedef DDS_DCPSSequence_out< _segments__seq > _segments__seq_out;
                struct _props__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::geographic_msgs::msg::dds_::KeyValue_, struct _props__seq_uniq_ > _props__seq;
                typedef DDS_DCPSSequence_var< _props__seq > _props__seq_var;
                typedef DDS_DCPSSequence_out< _props__seq > _props__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::unique_identifier_msgs::msg::dds_::UUID_ network_;
                _segments__seq segments_;
                _props__seq props_;
            };

            typedef DDS_DCPSStruct_var<RoutePath_> RoutePath__var;
            typedef DDS_DCPSStruct_out < RoutePath_> RoutePath__out;

        }

    }

}

#endif /* _H_6F637CAAE53569769B39DA354F899B19_RoutePath__H_ */
