#ifndef _H_6F637CAAE53569769B39DA354F899B19_RoutePath_DCPS_H_
#define _H_6F637CAAE53569769B39DA354F899B19_RoutePath_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RoutePath_.h"


namespace geographic_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RoutePath_TypeSupportInterface;

            typedef RoutePath_TypeSupportInterface * RoutePath_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RoutePath_TypeSupportInterface> RoutePath_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RoutePath_TypeSupportInterface> RoutePath_TypeSupportInterface_out;


            class RoutePath_DataWriter;

            typedef RoutePath_DataWriter * RoutePath_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RoutePath_DataWriter> RoutePath_DataWriter_var;
            typedef DDS_DCPSInterface_out < RoutePath_DataWriter> RoutePath_DataWriter_out;


            class RoutePath_DataReader;

            typedef RoutePath_DataReader * RoutePath_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RoutePath_DataReader> RoutePath_DataReader_var;
            typedef DDS_DCPSInterface_out < RoutePath_DataReader> RoutePath_DataReader_out;


            class RoutePath_DataReaderView;

            typedef RoutePath_DataReaderView * RoutePath_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RoutePath_DataReaderView> RoutePath_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RoutePath_DataReaderView> RoutePath_DataReaderView_out;

            struct RoutePath_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RoutePath_, struct RoutePath_Seq_uniq_> RoutePath_Seq;
            typedef DDS_DCPSSequence_var < RoutePath_Seq> RoutePath_Seq_var;
            typedef DDS_DCPSSequence_out < RoutePath_Seq> RoutePath_Seq_out;

            class  RoutePath_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RoutePath_TypeSupportInterface_ptr _ptr_type;
                typedef RoutePath_TypeSupportInterface_var _var_type;

                static RoutePath_TypeSupportInterface_ptr _duplicate (RoutePath_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RoutePath_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RoutePath_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RoutePath_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RoutePath_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RoutePath_TypeSupportInterface () {};
                ~RoutePath_TypeSupportInterface () {};
            private:
                RoutePath_TypeSupportInterface (const RoutePath_TypeSupportInterface &);
                RoutePath_TypeSupportInterface & operator = (const RoutePath_TypeSupportInterface &);
            };

            class  RoutePath_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RoutePath_DataWriter_ptr _ptr_type;
                typedef RoutePath_DataWriter_var _var_type;

                static RoutePath_DataWriter_ptr _duplicate (RoutePath_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RoutePath_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RoutePath_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RoutePath_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RoutePath_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RoutePath_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RoutePath_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RoutePath_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RoutePath_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RoutePath_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RoutePath_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RoutePath_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RoutePath_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RoutePath_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RoutePath_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RoutePath_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RoutePath_& instance_data) = 0;

            protected:
                RoutePath_DataWriter () {};
                ~RoutePath_DataWriter () {};
            private:
                RoutePath_DataWriter (const RoutePath_DataWriter &);
                RoutePath_DataWriter & operator = (const RoutePath_DataWriter &);
            };

            class  RoutePath_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RoutePath_DataReader_ptr _ptr_type;
                typedef RoutePath_DataReader_var _var_type;

                static RoutePath_DataReader_ptr _duplicate (RoutePath_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RoutePath_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RoutePath_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RoutePath_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RoutePath_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RoutePath_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RoutePath_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RoutePath_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RoutePath_& instance) = 0;

            protected:
                RoutePath_DataReader () {};
                ~RoutePath_DataReader () {};
            private:
                RoutePath_DataReader (const RoutePath_DataReader &);
                RoutePath_DataReader & operator = (const RoutePath_DataReader &);
            };

            class  RoutePath_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RoutePath_DataReaderView_ptr _ptr_type;
                typedef RoutePath_DataReaderView_var _var_type;

                static RoutePath_DataReaderView_ptr _duplicate (RoutePath_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RoutePath_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RoutePath_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RoutePath_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RoutePath_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RoutePath_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RoutePath_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RoutePath_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RoutePath_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RoutePath_& instance) = 0;

            protected:
                RoutePath_DataReaderView () {};
                ~RoutePath_DataReaderView () {};
            private:
                RoutePath_DataReaderView (const RoutePath_DataReaderView &);
                RoutePath_DataReaderView & operator = (const RoutePath_DataReaderView &);
            };
        }

    }

}

#endif
