#ifndef _H_11681084282409EFCCDD5A2883B4AFF2_RouteSegment_DCPS_H_
#define _H_11681084282409EFCCDD5A2883B4AFF2_RouteSegment_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RouteSegment_.h"


namespace geographic_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RouteSegment_TypeSupportInterface;

            typedef RouteSegment_TypeSupportInterface * RouteSegment_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RouteSegment_TypeSupportInterface> RouteSegment_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RouteSegment_TypeSupportInterface> RouteSegment_TypeSupportInterface_out;


            class RouteSegment_DataWriter;

            typedef RouteSegment_DataWriter * RouteSegment_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RouteSegment_DataWriter> RouteSegment_DataWriter_var;
            typedef DDS_DCPSInterface_out < RouteSegment_DataWriter> RouteSegment_DataWriter_out;


            class RouteSegment_DataReader;

            typedef RouteSegment_DataReader * RouteSegment_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RouteSegment_DataReader> RouteSegment_DataReader_var;
            typedef DDS_DCPSInterface_out < RouteSegment_DataReader> RouteSegment_DataReader_out;


            class RouteSegment_DataReaderView;

            typedef RouteSegment_DataReaderView * RouteSegment_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RouteSegment_DataReaderView> RouteSegment_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RouteSegment_DataReaderView> RouteSegment_DataReaderView_out;

            struct RouteSegment_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RouteSegment_, struct RouteSegment_Seq_uniq_> RouteSegment_Seq;
            typedef DDS_DCPSSequence_var < RouteSegment_Seq> RouteSegment_Seq_var;
            typedef DDS_DCPSSequence_out < RouteSegment_Seq> RouteSegment_Seq_out;

            class  RouteSegment_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RouteSegment_TypeSupportInterface_ptr _ptr_type;
                typedef RouteSegment_TypeSupportInterface_var _var_type;

                static RouteSegment_TypeSupportInterface_ptr _duplicate (RouteSegment_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RouteSegment_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RouteSegment_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RouteSegment_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RouteSegment_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RouteSegment_TypeSupportInterface () {};
                ~RouteSegment_TypeSupportInterface () {};
            private:
                RouteSegment_TypeSupportInterface (const RouteSegment_TypeSupportInterface &);
                RouteSegment_TypeSupportInterface & operator = (const RouteSegment_TypeSupportInterface &);
            };

            class  RouteSegment_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RouteSegment_DataWriter_ptr _ptr_type;
                typedef RouteSegment_DataWriter_var _var_type;

                static RouteSegment_DataWriter_ptr _duplicate (RouteSegment_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RouteSegment_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RouteSegment_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RouteSegment_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RouteSegment_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RouteSegment_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RouteSegment_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RouteSegment_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RouteSegment_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RouteSegment_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RouteSegment_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RouteSegment_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RouteSegment_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RouteSegment_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RouteSegment_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RouteSegment_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RouteSegment_& instance_data) = 0;

            protected:
                RouteSegment_DataWriter () {};
                ~RouteSegment_DataWriter () {};
            private:
                RouteSegment_DataWriter (const RouteSegment_DataWriter &);
                RouteSegment_DataWriter & operator = (const RouteSegment_DataWriter &);
            };

            class  RouteSegment_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RouteSegment_DataReader_ptr _ptr_type;
                typedef RouteSegment_DataReader_var _var_type;

                static RouteSegment_DataReader_ptr _duplicate (RouteSegment_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RouteSegment_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RouteSegment_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RouteSegment_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RouteSegment_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RouteSegment_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RouteSegment_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RouteSegment_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RouteSegment_& instance) = 0;

            protected:
                RouteSegment_DataReader () {};
                ~RouteSegment_DataReader () {};
            private:
                RouteSegment_DataReader (const RouteSegment_DataReader &);
                RouteSegment_DataReader & operator = (const RouteSegment_DataReader &);
            };

            class  RouteSegment_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RouteSegment_DataReaderView_ptr _ptr_type;
                typedef RouteSegment_DataReaderView_var _var_type;

                static RouteSegment_DataReaderView_ptr _duplicate (RouteSegment_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RouteSegment_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RouteSegment_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RouteSegment_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RouteSegment_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RouteSegment_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RouteSegment_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RouteSegment_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RouteSegment_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RouteSegment_& instance) = 0;

            protected:
                RouteSegment_DataReaderView () {};
                ~RouteSegment_DataReaderView () {};
            private:
                RouteSegment_DataReaderView (const RouteSegment_DataReaderView &);
                RouteSegment_DataReaderView & operator = (const RouteSegment_DataReaderView &);
            };
        }

    }

}

#endif
