#ifndef _H_E4FD0772C592C96074956D4AE4BE22A3_GetGeoPath__H_
#define _H_E4FD0772C592C96074956D4AE4BE22A3_GetGeoPath__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geographic_msgs/msg/dds_opensplice/GeoPoint_.h"
#include "geographic_msgs/msg/dds_opensplice/GeoPath_.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"


namespace geographic_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetGeoPath_Request_
            {
                ::geographic_msgs::msg::dds_::GeoPoint_ start_;
                ::geographic_msgs::msg::dds_::GeoPoint_ goal_;
            };

            typedef DDS_DCPSStruct_var<GetGeoPath_Request_> GetGeoPath_Request__var;
            typedef GetGeoPath_Request_& GetGeoPath_Request__out;

            struct  GetGeoPath_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr status_;
                ::geographic_msgs::msg::dds_::GeoPath_ plan_;
                ::unique_identifier_msgs::msg::dds_::UUID_ network_;
                ::unique_identifier_msgs::msg::dds_::UUID_ start_seg_;
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_seg_;
                ::DDS::Double distance_;
            };

            typedef DDS_DCPSStruct_var<GetGeoPath_Response_> GetGeoPath_Response__var;
            typedef DDS_DCPSStruct_out < GetGeoPath_Response_> GetGeoPath_Response__out;

            struct  Sample_GetGeoPath_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::geographic_msgs::srv::dds_::GetGeoPath_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetGeoPath_Request_> Sample_GetGeoPath_Request__var;
            typedef Sample_GetGeoPath_Request_& Sample_GetGeoPath_Request__out;

            struct  Sample_GetGeoPath_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::geographic_msgs::srv::dds_::GetGeoPath_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetGeoPath_Response_> Sample_GetGeoPath_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetGeoPath_Response_> Sample_GetGeoPath_Response__out;

        }

    }

}

#endif /* _H_E4FD0772C592C96074956D4AE4BE22A3_GetGeoPath__H_ */
