#ifndef H_E4FD0772C592C96074956D4AE4BE22A3_GetGeoPath_SPLTYPES_H
#define H_E4FD0772C592C96074956D4AE4BE22A3_GetGeoPath_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_GetGeoPath_.h"
#include "geographic_msgs/msg/dds_opensplice/GeoPoint_SplDcps.h"
#include "geographic_msgs/msg/dds_opensplice/GeoPath_SplDcps.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_SplDcps.h"



extern c_metaObject __GetGeoPath__geographic_msgs__load (c_base base);

extern c_metaObject __GetGeoPath__geographic_msgs_srv__load (c_base base);

extern c_metaObject __GetGeoPath__geographic_msgs_srv_dds___load (c_base base);

extern const char *geographic_msgs_srv_dds__GetGeoPath_Request__metaDescriptor[];
extern const int geographic_msgs_srv_dds__GetGeoPath_Request__metaDescriptorArrLength;
extern const int geographic_msgs_srv_dds__GetGeoPath_Request__metaDescriptorLength;
extern c_metaObject __geographic_msgs_srv_dds__GetGeoPath_Request___load (c_base base);
struct _geographic_msgs_srv_dds__GetGeoPath_Request_ ;
extern  v_copyin_result __geographic_msgs_srv_dds__GetGeoPath_Request___copyIn(c_base base, const struct geographic_msgs::srv::dds_::GetGeoPath_Request_ *from, struct _geographic_msgs_srv_dds__GetGeoPath_Request_ *to);
extern  void __geographic_msgs_srv_dds__GetGeoPath_Request___copyOut(const void *_from, void *_to);
struct _geographic_msgs_srv_dds__GetGeoPath_Request_ {
    struct _geographic_msgs_msg_dds__GeoPoint_ start_;
    struct _geographic_msgs_msg_dds__GeoPoint_ goal_;
};

extern const char *geographic_msgs_srv_dds__GetGeoPath_Response__metaDescriptor[];
extern const int geographic_msgs_srv_dds__GetGeoPath_Response__metaDescriptorArrLength;
extern const int geographic_msgs_srv_dds__GetGeoPath_Response__metaDescriptorLength;
extern c_metaObject __geographic_msgs_srv_dds__GetGeoPath_Response___load (c_base base);
struct _geographic_msgs_srv_dds__GetGeoPath_Response_ ;
extern  v_copyin_result __geographic_msgs_srv_dds__GetGeoPath_Response___copyIn(c_base base, const struct geographic_msgs::srv::dds_::GetGeoPath_Response_ *from, struct _geographic_msgs_srv_dds__GetGeoPath_Response_ *to);
extern  void __geographic_msgs_srv_dds__GetGeoPath_Response___copyOut(const void *_from, void *_to);
struct _geographic_msgs_srv_dds__GetGeoPath_Response_ {
    c_bool success_;
    c_string status_;
    struct _geographic_msgs_msg_dds__GeoPath_ plan_;
    struct _unique_identifier_msgs_msg_dds__UUID_ network_;
    struct _unique_identifier_msgs_msg_dds__UUID_ start_seg_;
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_seg_;
    c_double distance_;
};

extern const char *geographic_msgs_srv_dds__Sample_GetGeoPath_Request__metaDescriptor[];
extern const int geographic_msgs_srv_dds__Sample_GetGeoPath_Request__metaDescriptorArrLength;
extern const int geographic_msgs_srv_dds__Sample_GetGeoPath_Request__metaDescriptorLength;
extern c_metaObject __geographic_msgs_srv_dds__Sample_GetGeoPath_Request___load (c_base base);
struct _geographic_msgs_srv_dds__Sample_GetGeoPath_Request_ ;
extern  v_copyin_result __geographic_msgs_srv_dds__Sample_GetGeoPath_Request___copyIn(c_base base, const struct geographic_msgs::srv::dds_::Sample_GetGeoPath_Request_ *from, struct _geographic_msgs_srv_dds__Sample_GetGeoPath_Request_ *to);
extern  void __geographic_msgs_srv_dds__Sample_GetGeoPath_Request___copyOut(const void *_from, void *_to);
struct _geographic_msgs_srv_dds__Sample_GetGeoPath_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _geographic_msgs_srv_dds__GetGeoPath_Request_ request_;
};

extern const char *geographic_msgs_srv_dds__Sample_GetGeoPath_Response__metaDescriptor[];
extern const int geographic_msgs_srv_dds__Sample_GetGeoPath_Response__metaDescriptorArrLength;
extern const int geographic_msgs_srv_dds__Sample_GetGeoPath_Response__metaDescriptorLength;
extern c_metaObject __geographic_msgs_srv_dds__Sample_GetGeoPath_Response___load (c_base base);
struct _geographic_msgs_srv_dds__Sample_GetGeoPath_Response_ ;
extern  v_copyin_result __geographic_msgs_srv_dds__Sample_GetGeoPath_Response___copyIn(c_base base, const struct geographic_msgs::srv::dds_::Sample_GetGeoPath_Response_ *from, struct _geographic_msgs_srv_dds__Sample_GetGeoPath_Response_ *to);
extern  void __geographic_msgs_srv_dds__Sample_GetGeoPath_Response___copyOut(const void *_from, void *_to);
struct _geographic_msgs_srv_dds__Sample_GetGeoPath_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _geographic_msgs_srv_dds__GetGeoPath_Response_ response_;
};

#undef OS_API
#endif
