#ifndef _H_A949D7E2A52672442668DBEF14F5CCDD_GetGeographicMap__H_
#define _H_A949D7E2A52672442668DBEF14F5CCDD_GetGeographicMap__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geographic_msgs/msg/dds_opensplice/BoundingBox_.h"
#include "geographic_msgs/msg/dds_opensplice/GeographicMap_.h"


namespace geographic_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetGeographicMap_Request_
            {
                ::DDS::String_mgr url_;
                ::geographic_msgs::msg::dds_::BoundingBox_ bounds_;
            };

            typedef DDS_DCPSStruct_var<GetGeographicMap_Request_> GetGeographicMap_Request__var;
            typedef DDS_DCPSStruct_out < GetGeographicMap_Request_> GetGeographicMap_Request__out;

            struct  GetGeographicMap_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr status_;
                ::geographic_msgs::msg::dds_::GeographicMap_ map_;
            };

            typedef DDS_DCPSStruct_var<GetGeographicMap_Response_> GetGeographicMap_Response__var;
            typedef DDS_DCPSStruct_out < GetGeographicMap_Response_> GetGeographicMap_Response__out;

            struct  Sample_GetGeographicMap_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::geographic_msgs::srv::dds_::GetGeographicMap_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetGeographicMap_Request_> Sample_GetGeographicMap_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetGeographicMap_Request_> Sample_GetGeographicMap_Request__out;

            struct  Sample_GetGeographicMap_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::geographic_msgs::srv::dds_::GetGeographicMap_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetGeographicMap_Response_> Sample_GetGeographicMap_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetGeographicMap_Response_> Sample_GetGeographicMap_Response__out;

        }

    }

}

#endif /* _H_A949D7E2A52672442668DBEF14F5CCDD_GetGeographicMap__H_ */
