#ifndef _H_A949D7E2A52672442668DBEF14F5CCDD_GetGeographicMap_DCPS_H_
#define _H_A949D7E2A52672442668DBEF14F5CCDD_GetGeographicMap_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetGeographicMap_.h"


namespace geographic_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetGeographicMap_Request_TypeSupportInterface;

            typedef GetGeographicMap_Request_TypeSupportInterface * GetGeographicMap_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetGeographicMap_Request_TypeSupportInterface> GetGeographicMap_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetGeographicMap_Request_TypeSupportInterface> GetGeographicMap_Request_TypeSupportInterface_out;


            class GetGeographicMap_Request_DataWriter;

            typedef GetGeographicMap_Request_DataWriter * GetGeographicMap_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetGeographicMap_Request_DataWriter> GetGeographicMap_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetGeographicMap_Request_DataWriter> GetGeographicMap_Request_DataWriter_out;


            class GetGeographicMap_Request_DataReader;

            typedef GetGeographicMap_Request_DataReader * GetGeographicMap_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetGeographicMap_Request_DataReader> GetGeographicMap_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetGeographicMap_Request_DataReader> GetGeographicMap_Request_DataReader_out;


            class GetGeographicMap_Request_DataReaderView;

            typedef GetGeographicMap_Request_DataReaderView * GetGeographicMap_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetGeographicMap_Request_DataReaderView> GetGeographicMap_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetGeographicMap_Request_DataReaderView> GetGeographicMap_Request_DataReaderView_out;

            struct GetGeographicMap_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetGeographicMap_Request_, struct GetGeographicMap_Request_Seq_uniq_> GetGeographicMap_Request_Seq;
            typedef DDS_DCPSSequence_var < GetGeographicMap_Request_Seq> GetGeographicMap_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetGeographicMap_Request_Seq> GetGeographicMap_Request_Seq_out;

            class  GetGeographicMap_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetGeographicMap_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetGeographicMap_Request_TypeSupportInterface_var _var_type;

                static GetGeographicMap_Request_TypeSupportInterface_ptr _duplicate (GetGeographicMap_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeographicMap_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeographicMap_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetGeographicMap_Request_TypeSupportInterface () {};
                ~GetGeographicMap_Request_TypeSupportInterface () {};
            private:
                GetGeographicMap_Request_TypeSupportInterface (const GetGeographicMap_Request_TypeSupportInterface &);
                GetGeographicMap_Request_TypeSupportInterface & operator = (const GetGeographicMap_Request_TypeSupportInterface &);
            };

            class  GetGeographicMap_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetGeographicMap_Request_DataWriter_ptr _ptr_type;
                typedef GetGeographicMap_Request_DataWriter_var _var_type;

                static GetGeographicMap_Request_DataWriter_ptr _duplicate (GetGeographicMap_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeographicMap_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeographicMap_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetGeographicMap_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetGeographicMap_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetGeographicMap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetGeographicMap_Request_& instance_data) = 0;

            protected:
                GetGeographicMap_Request_DataWriter () {};
                ~GetGeographicMap_Request_DataWriter () {};
            private:
                GetGeographicMap_Request_DataWriter (const GetGeographicMap_Request_DataWriter &);
                GetGeographicMap_Request_DataWriter & operator = (const GetGeographicMap_Request_DataWriter &);
            };

            class  GetGeographicMap_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetGeographicMap_Request_DataReader_ptr _ptr_type;
                typedef GetGeographicMap_Request_DataReader_var _var_type;

                static GetGeographicMap_Request_DataReader_ptr _duplicate (GetGeographicMap_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeographicMap_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeographicMap_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetGeographicMap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetGeographicMap_Request_& instance) = 0;

            protected:
                GetGeographicMap_Request_DataReader () {};
                ~GetGeographicMap_Request_DataReader () {};
            private:
                GetGeographicMap_Request_DataReader (const GetGeographicMap_Request_DataReader &);
                GetGeographicMap_Request_DataReader & operator = (const GetGeographicMap_Request_DataReader &);
            };

            class  GetGeographicMap_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetGeographicMap_Request_DataReaderView_ptr _ptr_type;
                typedef GetGeographicMap_Request_DataReaderView_var _var_type;

                static GetGeographicMap_Request_DataReaderView_ptr _duplicate (GetGeographicMap_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeographicMap_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeographicMap_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetGeographicMap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetGeographicMap_Request_& instance) = 0;

            protected:
                GetGeographicMap_Request_DataReaderView () {};
                ~GetGeographicMap_Request_DataReaderView () {};
            private:
                GetGeographicMap_Request_DataReaderView (const GetGeographicMap_Request_DataReaderView &);
                GetGeographicMap_Request_DataReaderView & operator = (const GetGeographicMap_Request_DataReaderView &);
            };
            class GetGeographicMap_Response_TypeSupportInterface;

            typedef GetGeographicMap_Response_TypeSupportInterface * GetGeographicMap_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetGeographicMap_Response_TypeSupportInterface> GetGeographicMap_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetGeographicMap_Response_TypeSupportInterface> GetGeographicMap_Response_TypeSupportInterface_out;


            class GetGeographicMap_Response_DataWriter;

            typedef GetGeographicMap_Response_DataWriter * GetGeographicMap_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetGeographicMap_Response_DataWriter> GetGeographicMap_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetGeographicMap_Response_DataWriter> GetGeographicMap_Response_DataWriter_out;


            class GetGeographicMap_Response_DataReader;

            typedef GetGeographicMap_Response_DataReader * GetGeographicMap_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetGeographicMap_Response_DataReader> GetGeographicMap_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetGeographicMap_Response_DataReader> GetGeographicMap_Response_DataReader_out;


            class GetGeographicMap_Response_DataReaderView;

            typedef GetGeographicMap_Response_DataReaderView * GetGeographicMap_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetGeographicMap_Response_DataReaderView> GetGeographicMap_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetGeographicMap_Response_DataReaderView> GetGeographicMap_Response_DataReaderView_out;

            struct GetGeographicMap_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetGeographicMap_Response_, struct GetGeographicMap_Response_Seq_uniq_> GetGeographicMap_Response_Seq;
            typedef DDS_DCPSSequence_var < GetGeographicMap_Response_Seq> GetGeographicMap_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetGeographicMap_Response_Seq> GetGeographicMap_Response_Seq_out;

            class  GetGeographicMap_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetGeographicMap_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetGeographicMap_Response_TypeSupportInterface_var _var_type;

                static GetGeographicMap_Response_TypeSupportInterface_ptr _duplicate (GetGeographicMap_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeographicMap_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeographicMap_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetGeographicMap_Response_TypeSupportInterface () {};
                ~GetGeographicMap_Response_TypeSupportInterface () {};
            private:
                GetGeographicMap_Response_TypeSupportInterface (const GetGeographicMap_Response_TypeSupportInterface &);
                GetGeographicMap_Response_TypeSupportInterface & operator = (const GetGeographicMap_Response_TypeSupportInterface &);
            };

            class  GetGeographicMap_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetGeographicMap_Response_DataWriter_ptr _ptr_type;
                typedef GetGeographicMap_Response_DataWriter_var _var_type;

                static GetGeographicMap_Response_DataWriter_ptr _duplicate (GetGeographicMap_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeographicMap_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeographicMap_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetGeographicMap_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetGeographicMap_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetGeographicMap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetGeographicMap_Response_& instance_data) = 0;

            protected:
                GetGeographicMap_Response_DataWriter () {};
                ~GetGeographicMap_Response_DataWriter () {};
            private:
                GetGeographicMap_Response_DataWriter (const GetGeographicMap_Response_DataWriter &);
                GetGeographicMap_Response_DataWriter & operator = (const GetGeographicMap_Response_DataWriter &);
            };

            class  GetGeographicMap_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetGeographicMap_Response_DataReader_ptr _ptr_type;
                typedef GetGeographicMap_Response_DataReader_var _var_type;

                static GetGeographicMap_Response_DataReader_ptr _duplicate (GetGeographicMap_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeographicMap_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeographicMap_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetGeographicMap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetGeographicMap_Response_& instance) = 0;

            protected:
                GetGeographicMap_Response_DataReader () {};
                ~GetGeographicMap_Response_DataReader () {};
            private:
                GetGeographicMap_Response_DataReader (const GetGeographicMap_Response_DataReader &);
                GetGeographicMap_Response_DataReader & operator = (const GetGeographicMap_Response_DataReader &);
            };

            class  GetGeographicMap_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetGeographicMap_Response_DataReaderView_ptr _ptr_type;
                typedef GetGeographicMap_Response_DataReaderView_var _var_type;

                static GetGeographicMap_Response_DataReaderView_ptr _duplicate (GetGeographicMap_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetGeographicMap_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetGeographicMap_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetGeographicMap_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetGeographicMap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetGeographicMap_Response_& instance) = 0;

            protected:
                GetGeographicMap_Response_DataReaderView () {};
                ~GetGeographicMap_Response_DataReaderView () {};
            private:
                GetGeographicMap_Response_DataReaderView (const GetGeographicMap_Response_DataReaderView &);
                GetGeographicMap_Response_DataReaderView & operator = (const GetGeographicMap_Response_DataReaderView &);
            };
            class Sample_GetGeographicMap_Request_TypeSupportInterface;

            typedef Sample_GetGeographicMap_Request_TypeSupportInterface * Sample_GetGeographicMap_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeographicMap_Request_TypeSupportInterface> Sample_GetGeographicMap_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeographicMap_Request_TypeSupportInterface> Sample_GetGeographicMap_Request_TypeSupportInterface_out;


            class Sample_GetGeographicMap_Request_DataWriter;

            typedef Sample_GetGeographicMap_Request_DataWriter * Sample_GetGeographicMap_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeographicMap_Request_DataWriter> Sample_GetGeographicMap_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeographicMap_Request_DataWriter> Sample_GetGeographicMap_Request_DataWriter_out;


            class Sample_GetGeographicMap_Request_DataReader;

            typedef Sample_GetGeographicMap_Request_DataReader * Sample_GetGeographicMap_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeographicMap_Request_DataReader> Sample_GetGeographicMap_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeographicMap_Request_DataReader> Sample_GetGeographicMap_Request_DataReader_out;


            class Sample_GetGeographicMap_Request_DataReaderView;

            typedef Sample_GetGeographicMap_Request_DataReaderView * Sample_GetGeographicMap_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeographicMap_Request_DataReaderView> Sample_GetGeographicMap_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeographicMap_Request_DataReaderView> Sample_GetGeographicMap_Request_DataReaderView_out;

            struct Sample_GetGeographicMap_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetGeographicMap_Request_, struct Sample_GetGeographicMap_Request_Seq_uniq_> Sample_GetGeographicMap_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetGeographicMap_Request_Seq> Sample_GetGeographicMap_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetGeographicMap_Request_Seq> Sample_GetGeographicMap_Request_Seq_out;

            class  Sample_GetGeographicMap_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetGeographicMap_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetGeographicMap_Request_TypeSupportInterface_var _var_type;

                static Sample_GetGeographicMap_Request_TypeSupportInterface_ptr _duplicate (Sample_GetGeographicMap_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeographicMap_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeographicMap_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetGeographicMap_Request_TypeSupportInterface () {};
                ~Sample_GetGeographicMap_Request_TypeSupportInterface () {};
            private:
                Sample_GetGeographicMap_Request_TypeSupportInterface (const Sample_GetGeographicMap_Request_TypeSupportInterface &);
                Sample_GetGeographicMap_Request_TypeSupportInterface & operator = (const Sample_GetGeographicMap_Request_TypeSupportInterface &);
            };

            class  Sample_GetGeographicMap_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetGeographicMap_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetGeographicMap_Request_DataWriter_var _var_type;

                static Sample_GetGeographicMap_Request_DataWriter_ptr _duplicate (Sample_GetGeographicMap_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeographicMap_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeographicMap_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetGeographicMap_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetGeographicMap_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetGeographicMap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetGeographicMap_Request_& instance_data) = 0;

            protected:
                Sample_GetGeographicMap_Request_DataWriter () {};
                ~Sample_GetGeographicMap_Request_DataWriter () {};
            private:
                Sample_GetGeographicMap_Request_DataWriter (const Sample_GetGeographicMap_Request_DataWriter &);
                Sample_GetGeographicMap_Request_DataWriter & operator = (const Sample_GetGeographicMap_Request_DataWriter &);
            };

            class  Sample_GetGeographicMap_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetGeographicMap_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetGeographicMap_Request_DataReader_var _var_type;

                static Sample_GetGeographicMap_Request_DataReader_ptr _duplicate (Sample_GetGeographicMap_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeographicMap_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeographicMap_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetGeographicMap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetGeographicMap_Request_& instance) = 0;

            protected:
                Sample_GetGeographicMap_Request_DataReader () {};
                ~Sample_GetGeographicMap_Request_DataReader () {};
            private:
                Sample_GetGeographicMap_Request_DataReader (const Sample_GetGeographicMap_Request_DataReader &);
                Sample_GetGeographicMap_Request_DataReader & operator = (const Sample_GetGeographicMap_Request_DataReader &);
            };

            class  Sample_GetGeographicMap_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetGeographicMap_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetGeographicMap_Request_DataReaderView_var _var_type;

                static Sample_GetGeographicMap_Request_DataReaderView_ptr _duplicate (Sample_GetGeographicMap_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeographicMap_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeographicMap_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetGeographicMap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetGeographicMap_Request_& instance) = 0;

            protected:
                Sample_GetGeographicMap_Request_DataReaderView () {};
                ~Sample_GetGeographicMap_Request_DataReaderView () {};
            private:
                Sample_GetGeographicMap_Request_DataReaderView (const Sample_GetGeographicMap_Request_DataReaderView &);
                Sample_GetGeographicMap_Request_DataReaderView & operator = (const Sample_GetGeographicMap_Request_DataReaderView &);
            };
            class Sample_GetGeographicMap_Response_TypeSupportInterface;

            typedef Sample_GetGeographicMap_Response_TypeSupportInterface * Sample_GetGeographicMap_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeographicMap_Response_TypeSupportInterface> Sample_GetGeographicMap_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeographicMap_Response_TypeSupportInterface> Sample_GetGeographicMap_Response_TypeSupportInterface_out;


            class Sample_GetGeographicMap_Response_DataWriter;

            typedef Sample_GetGeographicMap_Response_DataWriter * Sample_GetGeographicMap_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeographicMap_Response_DataWriter> Sample_GetGeographicMap_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeographicMap_Response_DataWriter> Sample_GetGeographicMap_Response_DataWriter_out;


            class Sample_GetGeographicMap_Response_DataReader;

            typedef Sample_GetGeographicMap_Response_DataReader * Sample_GetGeographicMap_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeographicMap_Response_DataReader> Sample_GetGeographicMap_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeographicMap_Response_DataReader> Sample_GetGeographicMap_Response_DataReader_out;


            class Sample_GetGeographicMap_Response_DataReaderView;

            typedef Sample_GetGeographicMap_Response_DataReaderView * Sample_GetGeographicMap_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetGeographicMap_Response_DataReaderView> Sample_GetGeographicMap_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetGeographicMap_Response_DataReaderView> Sample_GetGeographicMap_Response_DataReaderView_out;

            struct Sample_GetGeographicMap_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetGeographicMap_Response_, struct Sample_GetGeographicMap_Response_Seq_uniq_> Sample_GetGeographicMap_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetGeographicMap_Response_Seq> Sample_GetGeographicMap_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetGeographicMap_Response_Seq> Sample_GetGeographicMap_Response_Seq_out;

            class  Sample_GetGeographicMap_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetGeographicMap_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetGeographicMap_Response_TypeSupportInterface_var _var_type;

                static Sample_GetGeographicMap_Response_TypeSupportInterface_ptr _duplicate (Sample_GetGeographicMap_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeographicMap_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeographicMap_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetGeographicMap_Response_TypeSupportInterface () {};
                ~Sample_GetGeographicMap_Response_TypeSupportInterface () {};
            private:
                Sample_GetGeographicMap_Response_TypeSupportInterface (const Sample_GetGeographicMap_Response_TypeSupportInterface &);
                Sample_GetGeographicMap_Response_TypeSupportInterface & operator = (const Sample_GetGeographicMap_Response_TypeSupportInterface &);
            };

            class  Sample_GetGeographicMap_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetGeographicMap_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetGeographicMap_Response_DataWriter_var _var_type;

                static Sample_GetGeographicMap_Response_DataWriter_ptr _duplicate (Sample_GetGeographicMap_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeographicMap_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeographicMap_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetGeographicMap_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetGeographicMap_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetGeographicMap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetGeographicMap_Response_& instance_data) = 0;

            protected:
                Sample_GetGeographicMap_Response_DataWriter () {};
                ~Sample_GetGeographicMap_Response_DataWriter () {};
            private:
                Sample_GetGeographicMap_Response_DataWriter (const Sample_GetGeographicMap_Response_DataWriter &);
                Sample_GetGeographicMap_Response_DataWriter & operator = (const Sample_GetGeographicMap_Response_DataWriter &);
            };

            class  Sample_GetGeographicMap_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetGeographicMap_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetGeographicMap_Response_DataReader_var _var_type;

                static Sample_GetGeographicMap_Response_DataReader_ptr _duplicate (Sample_GetGeographicMap_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeographicMap_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeographicMap_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetGeographicMap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetGeographicMap_Response_& instance) = 0;

            protected:
                Sample_GetGeographicMap_Response_DataReader () {};
                ~Sample_GetGeographicMap_Response_DataReader () {};
            private:
                Sample_GetGeographicMap_Response_DataReader (const Sample_GetGeographicMap_Response_DataReader &);
                Sample_GetGeographicMap_Response_DataReader & operator = (const Sample_GetGeographicMap_Response_DataReader &);
            };

            class  Sample_GetGeographicMap_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetGeographicMap_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetGeographicMap_Response_DataReaderView_var _var_type;

                static Sample_GetGeographicMap_Response_DataReaderView_ptr _duplicate (Sample_GetGeographicMap_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetGeographicMap_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetGeographicMap_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetGeographicMap_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetGeographicMap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetGeographicMap_Response_& instance) = 0;

            protected:
                Sample_GetGeographicMap_Response_DataReaderView () {};
                ~Sample_GetGeographicMap_Response_DataReaderView () {};
            private:
                Sample_GetGeographicMap_Response_DataReaderView (const Sample_GetGeographicMap_Response_DataReaderView &);
                Sample_GetGeographicMap_Response_DataReaderView & operator = (const Sample_GetGeographicMap_Response_DataReaderView &);
            };
        }

    }

}

#endif
