#ifndef _H_5A59EA0E5F0F0A750B09B36146064427_GetRoutePlan__H_
#define _H_5A59EA0E5F0F0A750B09B36146064427_GetRoutePlan__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"
#include "geographic_msgs/msg/dds_opensplice/RoutePath_.h"


namespace geographic_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetRoutePlan_Request_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ network_;
                ::unique_identifier_msgs::msg::dds_::UUID_ start_;
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_;
            };

            typedef DDS_DCPSStruct_var<GetRoutePlan_Request_> GetRoutePlan_Request__var;
            typedef GetRoutePlan_Request_& GetRoutePlan_Request__out;

            struct  GetRoutePlan_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr status_;
                ::geographic_msgs::msg::dds_::RoutePath_ plan_;
            };

            typedef DDS_DCPSStruct_var<GetRoutePlan_Response_> GetRoutePlan_Response__var;
            typedef DDS_DCPSStruct_out < GetRoutePlan_Response_> GetRoutePlan_Response__out;

            struct  Sample_GetRoutePlan_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::geographic_msgs::srv::dds_::GetRoutePlan_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetRoutePlan_Request_> Sample_GetRoutePlan_Request__var;
            typedef Sample_GetRoutePlan_Request_& Sample_GetRoutePlan_Request__out;

            struct  Sample_GetRoutePlan_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::geographic_msgs::srv::dds_::GetRoutePlan_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetRoutePlan_Response_> Sample_GetRoutePlan_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetRoutePlan_Response_> Sample_GetRoutePlan_Response__out;

        }

    }

}

#endif /* _H_5A59EA0E5F0F0A750B09B36146064427_GetRoutePlan__H_ */
