#ifndef _H_5A59EA0E5F0F0A750B09B36146064427_GetRoutePlan_DCPS_H_
#define _H_5A59EA0E5F0F0A750B09B36146064427_GetRoutePlan_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetRoutePlan_.h"


namespace geographic_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetRoutePlan_Request_TypeSupportInterface;

            typedef GetRoutePlan_Request_TypeSupportInterface * GetRoutePlan_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetRoutePlan_Request_TypeSupportInterface> GetRoutePlan_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetRoutePlan_Request_TypeSupportInterface> GetRoutePlan_Request_TypeSupportInterface_out;


            class GetRoutePlan_Request_DataWriter;

            typedef GetRoutePlan_Request_DataWriter * GetRoutePlan_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetRoutePlan_Request_DataWriter> GetRoutePlan_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetRoutePlan_Request_DataWriter> GetRoutePlan_Request_DataWriter_out;


            class GetRoutePlan_Request_DataReader;

            typedef GetRoutePlan_Request_DataReader * GetRoutePlan_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetRoutePlan_Request_DataReader> GetRoutePlan_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetRoutePlan_Request_DataReader> GetRoutePlan_Request_DataReader_out;


            class GetRoutePlan_Request_DataReaderView;

            typedef GetRoutePlan_Request_DataReaderView * GetRoutePlan_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetRoutePlan_Request_DataReaderView> GetRoutePlan_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetRoutePlan_Request_DataReaderView> GetRoutePlan_Request_DataReaderView_out;

            struct GetRoutePlan_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetRoutePlan_Request_, struct GetRoutePlan_Request_Seq_uniq_> GetRoutePlan_Request_Seq;
            typedef DDS_DCPSSequence_var < GetRoutePlan_Request_Seq> GetRoutePlan_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetRoutePlan_Request_Seq> GetRoutePlan_Request_Seq_out;

            class  GetRoutePlan_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetRoutePlan_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetRoutePlan_Request_TypeSupportInterface_var _var_type;

                static GetRoutePlan_Request_TypeSupportInterface_ptr _duplicate (GetRoutePlan_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoutePlan_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoutePlan_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetRoutePlan_Request_TypeSupportInterface () {};
                ~GetRoutePlan_Request_TypeSupportInterface () {};
            private:
                GetRoutePlan_Request_TypeSupportInterface (const GetRoutePlan_Request_TypeSupportInterface &);
                GetRoutePlan_Request_TypeSupportInterface & operator = (const GetRoutePlan_Request_TypeSupportInterface &);
            };

            class  GetRoutePlan_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetRoutePlan_Request_DataWriter_ptr _ptr_type;
                typedef GetRoutePlan_Request_DataWriter_var _var_type;

                static GetRoutePlan_Request_DataWriter_ptr _duplicate (GetRoutePlan_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoutePlan_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoutePlan_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetRoutePlan_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetRoutePlan_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetRoutePlan_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetRoutePlan_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetRoutePlan_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetRoutePlan_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetRoutePlan_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetRoutePlan_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetRoutePlan_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetRoutePlan_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetRoutePlan_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRoutePlan_Request_& instance_data) = 0;

            protected:
                GetRoutePlan_Request_DataWriter () {};
                ~GetRoutePlan_Request_DataWriter () {};
            private:
                GetRoutePlan_Request_DataWriter (const GetRoutePlan_Request_DataWriter &);
                GetRoutePlan_Request_DataWriter & operator = (const GetRoutePlan_Request_DataWriter &);
            };

            class  GetRoutePlan_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetRoutePlan_Request_DataReader_ptr _ptr_type;
                typedef GetRoutePlan_Request_DataReader_var _var_type;

                static GetRoutePlan_Request_DataReader_ptr _duplicate (GetRoutePlan_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoutePlan_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoutePlan_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetRoutePlan_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetRoutePlan_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetRoutePlan_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRoutePlan_Request_& instance) = 0;

            protected:
                GetRoutePlan_Request_DataReader () {};
                ~GetRoutePlan_Request_DataReader () {};
            private:
                GetRoutePlan_Request_DataReader (const GetRoutePlan_Request_DataReader &);
                GetRoutePlan_Request_DataReader & operator = (const GetRoutePlan_Request_DataReader &);
            };

            class  GetRoutePlan_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetRoutePlan_Request_DataReaderView_ptr _ptr_type;
                typedef GetRoutePlan_Request_DataReaderView_var _var_type;

                static GetRoutePlan_Request_DataReaderView_ptr _duplicate (GetRoutePlan_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoutePlan_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoutePlan_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetRoutePlan_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetRoutePlan_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetRoutePlan_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRoutePlan_Request_& instance) = 0;

            protected:
                GetRoutePlan_Request_DataReaderView () {};
                ~GetRoutePlan_Request_DataReaderView () {};
            private:
                GetRoutePlan_Request_DataReaderView (const GetRoutePlan_Request_DataReaderView &);
                GetRoutePlan_Request_DataReaderView & operator = (const GetRoutePlan_Request_DataReaderView &);
            };
            class GetRoutePlan_Response_TypeSupportInterface;

            typedef GetRoutePlan_Response_TypeSupportInterface * GetRoutePlan_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetRoutePlan_Response_TypeSupportInterface> GetRoutePlan_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetRoutePlan_Response_TypeSupportInterface> GetRoutePlan_Response_TypeSupportInterface_out;


            class GetRoutePlan_Response_DataWriter;

            typedef GetRoutePlan_Response_DataWriter * GetRoutePlan_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetRoutePlan_Response_DataWriter> GetRoutePlan_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetRoutePlan_Response_DataWriter> GetRoutePlan_Response_DataWriter_out;


            class GetRoutePlan_Response_DataReader;

            typedef GetRoutePlan_Response_DataReader * GetRoutePlan_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetRoutePlan_Response_DataReader> GetRoutePlan_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetRoutePlan_Response_DataReader> GetRoutePlan_Response_DataReader_out;


            class GetRoutePlan_Response_DataReaderView;

            typedef GetRoutePlan_Response_DataReaderView * GetRoutePlan_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetRoutePlan_Response_DataReaderView> GetRoutePlan_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetRoutePlan_Response_DataReaderView> GetRoutePlan_Response_DataReaderView_out;

            struct GetRoutePlan_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetRoutePlan_Response_, struct GetRoutePlan_Response_Seq_uniq_> GetRoutePlan_Response_Seq;
            typedef DDS_DCPSSequence_var < GetRoutePlan_Response_Seq> GetRoutePlan_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetRoutePlan_Response_Seq> GetRoutePlan_Response_Seq_out;

            class  GetRoutePlan_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetRoutePlan_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetRoutePlan_Response_TypeSupportInterface_var _var_type;

                static GetRoutePlan_Response_TypeSupportInterface_ptr _duplicate (GetRoutePlan_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoutePlan_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoutePlan_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetRoutePlan_Response_TypeSupportInterface () {};
                ~GetRoutePlan_Response_TypeSupportInterface () {};
            private:
                GetRoutePlan_Response_TypeSupportInterface (const GetRoutePlan_Response_TypeSupportInterface &);
                GetRoutePlan_Response_TypeSupportInterface & operator = (const GetRoutePlan_Response_TypeSupportInterface &);
            };

            class  GetRoutePlan_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetRoutePlan_Response_DataWriter_ptr _ptr_type;
                typedef GetRoutePlan_Response_DataWriter_var _var_type;

                static GetRoutePlan_Response_DataWriter_ptr _duplicate (GetRoutePlan_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoutePlan_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoutePlan_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetRoutePlan_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetRoutePlan_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetRoutePlan_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetRoutePlan_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetRoutePlan_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetRoutePlan_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetRoutePlan_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetRoutePlan_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetRoutePlan_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetRoutePlan_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetRoutePlan_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRoutePlan_Response_& instance_data) = 0;

            protected:
                GetRoutePlan_Response_DataWriter () {};
                ~GetRoutePlan_Response_DataWriter () {};
            private:
                GetRoutePlan_Response_DataWriter (const GetRoutePlan_Response_DataWriter &);
                GetRoutePlan_Response_DataWriter & operator = (const GetRoutePlan_Response_DataWriter &);
            };

            class  GetRoutePlan_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetRoutePlan_Response_DataReader_ptr _ptr_type;
                typedef GetRoutePlan_Response_DataReader_var _var_type;

                static GetRoutePlan_Response_DataReader_ptr _duplicate (GetRoutePlan_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoutePlan_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoutePlan_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetRoutePlan_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetRoutePlan_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetRoutePlan_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRoutePlan_Response_& instance) = 0;

            protected:
                GetRoutePlan_Response_DataReader () {};
                ~GetRoutePlan_Response_DataReader () {};
            private:
                GetRoutePlan_Response_DataReader (const GetRoutePlan_Response_DataReader &);
                GetRoutePlan_Response_DataReader & operator = (const GetRoutePlan_Response_DataReader &);
            };

            class  GetRoutePlan_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetRoutePlan_Response_DataReaderView_ptr _ptr_type;
                typedef GetRoutePlan_Response_DataReaderView_var _var_type;

                static GetRoutePlan_Response_DataReaderView_ptr _duplicate (GetRoutePlan_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoutePlan_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoutePlan_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoutePlan_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetRoutePlan_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetRoutePlan_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetRoutePlan_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRoutePlan_Response_& instance) = 0;

            protected:
                GetRoutePlan_Response_DataReaderView () {};
                ~GetRoutePlan_Response_DataReaderView () {};
            private:
                GetRoutePlan_Response_DataReaderView (const GetRoutePlan_Response_DataReaderView &);
                GetRoutePlan_Response_DataReaderView & operator = (const GetRoutePlan_Response_DataReaderView &);
            };
            class Sample_GetRoutePlan_Request_TypeSupportInterface;

            typedef Sample_GetRoutePlan_Request_TypeSupportInterface * Sample_GetRoutePlan_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoutePlan_Request_TypeSupportInterface> Sample_GetRoutePlan_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoutePlan_Request_TypeSupportInterface> Sample_GetRoutePlan_Request_TypeSupportInterface_out;


            class Sample_GetRoutePlan_Request_DataWriter;

            typedef Sample_GetRoutePlan_Request_DataWriter * Sample_GetRoutePlan_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoutePlan_Request_DataWriter> Sample_GetRoutePlan_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoutePlan_Request_DataWriter> Sample_GetRoutePlan_Request_DataWriter_out;


            class Sample_GetRoutePlan_Request_DataReader;

            typedef Sample_GetRoutePlan_Request_DataReader * Sample_GetRoutePlan_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoutePlan_Request_DataReader> Sample_GetRoutePlan_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoutePlan_Request_DataReader> Sample_GetRoutePlan_Request_DataReader_out;


            class Sample_GetRoutePlan_Request_DataReaderView;

            typedef Sample_GetRoutePlan_Request_DataReaderView * Sample_GetRoutePlan_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoutePlan_Request_DataReaderView> Sample_GetRoutePlan_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoutePlan_Request_DataReaderView> Sample_GetRoutePlan_Request_DataReaderView_out;

            struct Sample_GetRoutePlan_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetRoutePlan_Request_, struct Sample_GetRoutePlan_Request_Seq_uniq_> Sample_GetRoutePlan_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetRoutePlan_Request_Seq> Sample_GetRoutePlan_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetRoutePlan_Request_Seq> Sample_GetRoutePlan_Request_Seq_out;

            class  Sample_GetRoutePlan_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetRoutePlan_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetRoutePlan_Request_TypeSupportInterface_var _var_type;

                static Sample_GetRoutePlan_Request_TypeSupportInterface_ptr _duplicate (Sample_GetRoutePlan_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoutePlan_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoutePlan_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetRoutePlan_Request_TypeSupportInterface () {};
                ~Sample_GetRoutePlan_Request_TypeSupportInterface () {};
            private:
                Sample_GetRoutePlan_Request_TypeSupportInterface (const Sample_GetRoutePlan_Request_TypeSupportInterface &);
                Sample_GetRoutePlan_Request_TypeSupportInterface & operator = (const Sample_GetRoutePlan_Request_TypeSupportInterface &);
            };

            class  Sample_GetRoutePlan_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetRoutePlan_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetRoutePlan_Request_DataWriter_var _var_type;

                static Sample_GetRoutePlan_Request_DataWriter_ptr _duplicate (Sample_GetRoutePlan_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoutePlan_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoutePlan_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetRoutePlan_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetRoutePlan_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetRoutePlan_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetRoutePlan_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetRoutePlan_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetRoutePlan_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetRoutePlan_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetRoutePlan_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetRoutePlan_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetRoutePlan_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetRoutePlan_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRoutePlan_Request_& instance_data) = 0;

            protected:
                Sample_GetRoutePlan_Request_DataWriter () {};
                ~Sample_GetRoutePlan_Request_DataWriter () {};
            private:
                Sample_GetRoutePlan_Request_DataWriter (const Sample_GetRoutePlan_Request_DataWriter &);
                Sample_GetRoutePlan_Request_DataWriter & operator = (const Sample_GetRoutePlan_Request_DataWriter &);
            };

            class  Sample_GetRoutePlan_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetRoutePlan_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetRoutePlan_Request_DataReader_var _var_type;

                static Sample_GetRoutePlan_Request_DataReader_ptr _duplicate (Sample_GetRoutePlan_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoutePlan_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoutePlan_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetRoutePlan_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetRoutePlan_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetRoutePlan_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRoutePlan_Request_& instance) = 0;

            protected:
                Sample_GetRoutePlan_Request_DataReader () {};
                ~Sample_GetRoutePlan_Request_DataReader () {};
            private:
                Sample_GetRoutePlan_Request_DataReader (const Sample_GetRoutePlan_Request_DataReader &);
                Sample_GetRoutePlan_Request_DataReader & operator = (const Sample_GetRoutePlan_Request_DataReader &);
            };

            class  Sample_GetRoutePlan_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetRoutePlan_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetRoutePlan_Request_DataReaderView_var _var_type;

                static Sample_GetRoutePlan_Request_DataReaderView_ptr _duplicate (Sample_GetRoutePlan_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoutePlan_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoutePlan_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetRoutePlan_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetRoutePlan_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetRoutePlan_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetRoutePlan_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRoutePlan_Request_& instance) = 0;

            protected:
                Sample_GetRoutePlan_Request_DataReaderView () {};
                ~Sample_GetRoutePlan_Request_DataReaderView () {};
            private:
                Sample_GetRoutePlan_Request_DataReaderView (const Sample_GetRoutePlan_Request_DataReaderView &);
                Sample_GetRoutePlan_Request_DataReaderView & operator = (const Sample_GetRoutePlan_Request_DataReaderView &);
            };
            class Sample_GetRoutePlan_Response_TypeSupportInterface;

            typedef Sample_GetRoutePlan_Response_TypeSupportInterface * Sample_GetRoutePlan_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoutePlan_Response_TypeSupportInterface> Sample_GetRoutePlan_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoutePlan_Response_TypeSupportInterface> Sample_GetRoutePlan_Response_TypeSupportInterface_out;


            class Sample_GetRoutePlan_Response_DataWriter;

            typedef Sample_GetRoutePlan_Response_DataWriter * Sample_GetRoutePlan_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoutePlan_Response_DataWriter> Sample_GetRoutePlan_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoutePlan_Response_DataWriter> Sample_GetRoutePlan_Response_DataWriter_out;


            class Sample_GetRoutePlan_Response_DataReader;

            typedef Sample_GetRoutePlan_Response_DataReader * Sample_GetRoutePlan_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoutePlan_Response_DataReader> Sample_GetRoutePlan_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoutePlan_Response_DataReader> Sample_GetRoutePlan_Response_DataReader_out;


            class Sample_GetRoutePlan_Response_DataReaderView;

            typedef Sample_GetRoutePlan_Response_DataReaderView * Sample_GetRoutePlan_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoutePlan_Response_DataReaderView> Sample_GetRoutePlan_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoutePlan_Response_DataReaderView> Sample_GetRoutePlan_Response_DataReaderView_out;

            struct Sample_GetRoutePlan_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetRoutePlan_Response_, struct Sample_GetRoutePlan_Response_Seq_uniq_> Sample_GetRoutePlan_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetRoutePlan_Response_Seq> Sample_GetRoutePlan_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetRoutePlan_Response_Seq> Sample_GetRoutePlan_Response_Seq_out;

            class  Sample_GetRoutePlan_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetRoutePlan_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetRoutePlan_Response_TypeSupportInterface_var _var_type;

                static Sample_GetRoutePlan_Response_TypeSupportInterface_ptr _duplicate (Sample_GetRoutePlan_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoutePlan_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoutePlan_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetRoutePlan_Response_TypeSupportInterface () {};
                ~Sample_GetRoutePlan_Response_TypeSupportInterface () {};
            private:
                Sample_GetRoutePlan_Response_TypeSupportInterface (const Sample_GetRoutePlan_Response_TypeSupportInterface &);
                Sample_GetRoutePlan_Response_TypeSupportInterface & operator = (const Sample_GetRoutePlan_Response_TypeSupportInterface &);
            };

            class  Sample_GetRoutePlan_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetRoutePlan_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetRoutePlan_Response_DataWriter_var _var_type;

                static Sample_GetRoutePlan_Response_DataWriter_ptr _duplicate (Sample_GetRoutePlan_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoutePlan_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoutePlan_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetRoutePlan_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetRoutePlan_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetRoutePlan_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetRoutePlan_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetRoutePlan_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetRoutePlan_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetRoutePlan_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetRoutePlan_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetRoutePlan_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetRoutePlan_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetRoutePlan_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRoutePlan_Response_& instance_data) = 0;

            protected:
                Sample_GetRoutePlan_Response_DataWriter () {};
                ~Sample_GetRoutePlan_Response_DataWriter () {};
            private:
                Sample_GetRoutePlan_Response_DataWriter (const Sample_GetRoutePlan_Response_DataWriter &);
                Sample_GetRoutePlan_Response_DataWriter & operator = (const Sample_GetRoutePlan_Response_DataWriter &);
            };

            class  Sample_GetRoutePlan_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetRoutePlan_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetRoutePlan_Response_DataReader_var _var_type;

                static Sample_GetRoutePlan_Response_DataReader_ptr _duplicate (Sample_GetRoutePlan_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoutePlan_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoutePlan_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetRoutePlan_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetRoutePlan_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetRoutePlan_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRoutePlan_Response_& instance) = 0;

            protected:
                Sample_GetRoutePlan_Response_DataReader () {};
                ~Sample_GetRoutePlan_Response_DataReader () {};
            private:
                Sample_GetRoutePlan_Response_DataReader (const Sample_GetRoutePlan_Response_DataReader &);
                Sample_GetRoutePlan_Response_DataReader & operator = (const Sample_GetRoutePlan_Response_DataReader &);
            };

            class  Sample_GetRoutePlan_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetRoutePlan_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetRoutePlan_Response_DataReaderView_var _var_type;

                static Sample_GetRoutePlan_Response_DataReaderView_ptr _duplicate (Sample_GetRoutePlan_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoutePlan_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoutePlan_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoutePlan_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetRoutePlan_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetRoutePlan_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetRoutePlan_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetRoutePlan_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRoutePlan_Response_& instance) = 0;

            protected:
                Sample_GetRoutePlan_Response_DataReaderView () {};
                ~Sample_GetRoutePlan_Response_DataReaderView () {};
            private:
                Sample_GetRoutePlan_Response_DataReaderView (const Sample_GetRoutePlan_Response_DataReaderView &);
                Sample_GetRoutePlan_Response_DataReaderView & operator = (const Sample_GetRoutePlan_Response_DataReaderView &);
            };
        }

    }

}

#endif
