#ifndef H_5A59EA0E5F0F0A750B09B36146064427_GetRoutePlan_SPLTYPES_H
#define H_5A59EA0E5F0F0A750B09B36146064427_GetRoutePlan_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_GetRoutePlan_.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_SplDcps.h"
#include "geographic_msgs/msg/dds_opensplice/RoutePath_SplDcps.h"



extern c_metaObject __GetRoutePlan__geographic_msgs__load (c_base base);

extern c_metaObject __GetRoutePlan__geographic_msgs_srv__load (c_base base);

extern c_metaObject __GetRoutePlan__geographic_msgs_srv_dds___load (c_base base);

extern const char *geographic_msgs_srv_dds__GetRoutePlan_Request__metaDescriptor[];
extern const int geographic_msgs_srv_dds__GetRoutePlan_Request__metaDescriptorArrLength;
extern const int geographic_msgs_srv_dds__GetRoutePlan_Request__metaDescriptorLength;
extern c_metaObject __geographic_msgs_srv_dds__GetRoutePlan_Request___load (c_base base);
struct _geographic_msgs_srv_dds__GetRoutePlan_Request_ ;
extern  v_copyin_result __geographic_msgs_srv_dds__GetRoutePlan_Request___copyIn(c_base base, const struct geographic_msgs::srv::dds_::GetRoutePlan_Request_ *from, struct _geographic_msgs_srv_dds__GetRoutePlan_Request_ *to);
extern  void __geographic_msgs_srv_dds__GetRoutePlan_Request___copyOut(const void *_from, void *_to);
struct _geographic_msgs_srv_dds__GetRoutePlan_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ network_;
    struct _unique_identifier_msgs_msg_dds__UUID_ start_;
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_;
};

extern const char *geographic_msgs_srv_dds__GetRoutePlan_Response__metaDescriptor[];
extern const int geographic_msgs_srv_dds__GetRoutePlan_Response__metaDescriptorArrLength;
extern const int geographic_msgs_srv_dds__GetRoutePlan_Response__metaDescriptorLength;
extern c_metaObject __geographic_msgs_srv_dds__GetRoutePlan_Response___load (c_base base);
struct _geographic_msgs_srv_dds__GetRoutePlan_Response_ ;
extern  v_copyin_result __geographic_msgs_srv_dds__GetRoutePlan_Response___copyIn(c_base base, const struct geographic_msgs::srv::dds_::GetRoutePlan_Response_ *from, struct _geographic_msgs_srv_dds__GetRoutePlan_Response_ *to);
extern  void __geographic_msgs_srv_dds__GetRoutePlan_Response___copyOut(const void *_from, void *_to);
struct _geographic_msgs_srv_dds__GetRoutePlan_Response_ {
    c_bool success_;
    c_string status_;
    struct _geographic_msgs_msg_dds__RoutePath_ plan_;
};

extern const char *geographic_msgs_srv_dds__Sample_GetRoutePlan_Request__metaDescriptor[];
extern const int geographic_msgs_srv_dds__Sample_GetRoutePlan_Request__metaDescriptorArrLength;
extern const int geographic_msgs_srv_dds__Sample_GetRoutePlan_Request__metaDescriptorLength;
extern c_metaObject __geographic_msgs_srv_dds__Sample_GetRoutePlan_Request___load (c_base base);
struct _geographic_msgs_srv_dds__Sample_GetRoutePlan_Request_ ;
extern  v_copyin_result __geographic_msgs_srv_dds__Sample_GetRoutePlan_Request___copyIn(c_base base, const struct geographic_msgs::srv::dds_::Sample_GetRoutePlan_Request_ *from, struct _geographic_msgs_srv_dds__Sample_GetRoutePlan_Request_ *to);
extern  void __geographic_msgs_srv_dds__Sample_GetRoutePlan_Request___copyOut(const void *_from, void *_to);
struct _geographic_msgs_srv_dds__Sample_GetRoutePlan_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _geographic_msgs_srv_dds__GetRoutePlan_Request_ request_;
};

extern const char *geographic_msgs_srv_dds__Sample_GetRoutePlan_Response__metaDescriptor[];
extern const int geographic_msgs_srv_dds__Sample_GetRoutePlan_Response__metaDescriptorArrLength;
extern const int geographic_msgs_srv_dds__Sample_GetRoutePlan_Response__metaDescriptorLength;
extern c_metaObject __geographic_msgs_srv_dds__Sample_GetRoutePlan_Response___load (c_base base);
struct _geographic_msgs_srv_dds__Sample_GetRoutePlan_Response_ ;
extern  v_copyin_result __geographic_msgs_srv_dds__Sample_GetRoutePlan_Response___copyIn(c_base base, const struct geographic_msgs::srv::dds_::Sample_GetRoutePlan_Response_ *from, struct _geographic_msgs_srv_dds__Sample_GetRoutePlan_Response_ *to);
extern  void __geographic_msgs_srv_dds__Sample_GetRoutePlan_Response___copyOut(const void *_from, void *_to);
struct _geographic_msgs_srv_dds__Sample_GetRoutePlan_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _geographic_msgs_srv_dds__GetRoutePlan_Response_ response_;
};

#undef OS_API
#endif
