#ifndef _H_6418FE42C19696DF9EF2E2B0C211F62F_UpdateGeographicMap_DCPS_H_
#define _H_6418FE42C19696DF9EF2E2B0C211F62F_UpdateGeographicMap_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UpdateGeographicMap_.h"


namespace geographic_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class UpdateGeographicMap_Request_TypeSupportInterface;

            typedef UpdateGeographicMap_Request_TypeSupportInterface * UpdateGeographicMap_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UpdateGeographicMap_Request_TypeSupportInterface> UpdateGeographicMap_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UpdateGeographicMap_Request_TypeSupportInterface> UpdateGeographicMap_Request_TypeSupportInterface_out;


            class UpdateGeographicMap_Request_DataWriter;

            typedef UpdateGeographicMap_Request_DataWriter * UpdateGeographicMap_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UpdateGeographicMap_Request_DataWriter> UpdateGeographicMap_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < UpdateGeographicMap_Request_DataWriter> UpdateGeographicMap_Request_DataWriter_out;


            class UpdateGeographicMap_Request_DataReader;

            typedef UpdateGeographicMap_Request_DataReader * UpdateGeographicMap_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UpdateGeographicMap_Request_DataReader> UpdateGeographicMap_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < UpdateGeographicMap_Request_DataReader> UpdateGeographicMap_Request_DataReader_out;


            class UpdateGeographicMap_Request_DataReaderView;

            typedef UpdateGeographicMap_Request_DataReaderView * UpdateGeographicMap_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UpdateGeographicMap_Request_DataReaderView> UpdateGeographicMap_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UpdateGeographicMap_Request_DataReaderView> UpdateGeographicMap_Request_DataReaderView_out;

            struct UpdateGeographicMap_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < UpdateGeographicMap_Request_, struct UpdateGeographicMap_Request_Seq_uniq_> UpdateGeographicMap_Request_Seq;
            typedef DDS_DCPSSequence_var < UpdateGeographicMap_Request_Seq> UpdateGeographicMap_Request_Seq_var;
            typedef DDS_DCPSSequence_out < UpdateGeographicMap_Request_Seq> UpdateGeographicMap_Request_Seq_out;

            class  UpdateGeographicMap_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UpdateGeographicMap_Request_TypeSupportInterface_ptr _ptr_type;
                typedef UpdateGeographicMap_Request_TypeSupportInterface_var _var_type;

                static UpdateGeographicMap_Request_TypeSupportInterface_ptr _duplicate (UpdateGeographicMap_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateGeographicMap_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateGeographicMap_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UpdateGeographicMap_Request_TypeSupportInterface () {};
                ~UpdateGeographicMap_Request_TypeSupportInterface () {};
            private:
                UpdateGeographicMap_Request_TypeSupportInterface (const UpdateGeographicMap_Request_TypeSupportInterface &);
                UpdateGeographicMap_Request_TypeSupportInterface & operator = (const UpdateGeographicMap_Request_TypeSupportInterface &);
            };

            class  UpdateGeographicMap_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UpdateGeographicMap_Request_DataWriter_ptr _ptr_type;
                typedef UpdateGeographicMap_Request_DataWriter_var _var_type;

                static UpdateGeographicMap_Request_DataWriter_ptr _duplicate (UpdateGeographicMap_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateGeographicMap_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateGeographicMap_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UpdateGeographicMap_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UpdateGeographicMap_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UpdateGeographicMap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UpdateGeographicMap_Request_& instance_data) = 0;

            protected:
                UpdateGeographicMap_Request_DataWriter () {};
                ~UpdateGeographicMap_Request_DataWriter () {};
            private:
                UpdateGeographicMap_Request_DataWriter (const UpdateGeographicMap_Request_DataWriter &);
                UpdateGeographicMap_Request_DataWriter & operator = (const UpdateGeographicMap_Request_DataWriter &);
            };

            class  UpdateGeographicMap_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UpdateGeographicMap_Request_DataReader_ptr _ptr_type;
                typedef UpdateGeographicMap_Request_DataReader_var _var_type;

                static UpdateGeographicMap_Request_DataReader_ptr _duplicate (UpdateGeographicMap_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateGeographicMap_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateGeographicMap_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UpdateGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UpdateGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UpdateGeographicMap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UpdateGeographicMap_Request_& instance) = 0;

            protected:
                UpdateGeographicMap_Request_DataReader () {};
                ~UpdateGeographicMap_Request_DataReader () {};
            private:
                UpdateGeographicMap_Request_DataReader (const UpdateGeographicMap_Request_DataReader &);
                UpdateGeographicMap_Request_DataReader & operator = (const UpdateGeographicMap_Request_DataReader &);
            };

            class  UpdateGeographicMap_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UpdateGeographicMap_Request_DataReaderView_ptr _ptr_type;
                typedef UpdateGeographicMap_Request_DataReaderView_var _var_type;

                static UpdateGeographicMap_Request_DataReaderView_ptr _duplicate (UpdateGeographicMap_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateGeographicMap_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateGeographicMap_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UpdateGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UpdateGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UpdateGeographicMap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UpdateGeographicMap_Request_& instance) = 0;

            protected:
                UpdateGeographicMap_Request_DataReaderView () {};
                ~UpdateGeographicMap_Request_DataReaderView () {};
            private:
                UpdateGeographicMap_Request_DataReaderView (const UpdateGeographicMap_Request_DataReaderView &);
                UpdateGeographicMap_Request_DataReaderView & operator = (const UpdateGeographicMap_Request_DataReaderView &);
            };
            class UpdateGeographicMap_Response_TypeSupportInterface;

            typedef UpdateGeographicMap_Response_TypeSupportInterface * UpdateGeographicMap_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UpdateGeographicMap_Response_TypeSupportInterface> UpdateGeographicMap_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UpdateGeographicMap_Response_TypeSupportInterface> UpdateGeographicMap_Response_TypeSupportInterface_out;


            class UpdateGeographicMap_Response_DataWriter;

            typedef UpdateGeographicMap_Response_DataWriter * UpdateGeographicMap_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UpdateGeographicMap_Response_DataWriter> UpdateGeographicMap_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < UpdateGeographicMap_Response_DataWriter> UpdateGeographicMap_Response_DataWriter_out;


            class UpdateGeographicMap_Response_DataReader;

            typedef UpdateGeographicMap_Response_DataReader * UpdateGeographicMap_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UpdateGeographicMap_Response_DataReader> UpdateGeographicMap_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < UpdateGeographicMap_Response_DataReader> UpdateGeographicMap_Response_DataReader_out;


            class UpdateGeographicMap_Response_DataReaderView;

            typedef UpdateGeographicMap_Response_DataReaderView * UpdateGeographicMap_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UpdateGeographicMap_Response_DataReaderView> UpdateGeographicMap_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UpdateGeographicMap_Response_DataReaderView> UpdateGeographicMap_Response_DataReaderView_out;

            struct UpdateGeographicMap_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < UpdateGeographicMap_Response_, struct UpdateGeographicMap_Response_Seq_uniq_> UpdateGeographicMap_Response_Seq;
            typedef DDS_DCPSSequence_var < UpdateGeographicMap_Response_Seq> UpdateGeographicMap_Response_Seq_var;
            typedef DDS_DCPSSequence_out < UpdateGeographicMap_Response_Seq> UpdateGeographicMap_Response_Seq_out;

            class  UpdateGeographicMap_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UpdateGeographicMap_Response_TypeSupportInterface_ptr _ptr_type;
                typedef UpdateGeographicMap_Response_TypeSupportInterface_var _var_type;

                static UpdateGeographicMap_Response_TypeSupportInterface_ptr _duplicate (UpdateGeographicMap_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateGeographicMap_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateGeographicMap_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UpdateGeographicMap_Response_TypeSupportInterface () {};
                ~UpdateGeographicMap_Response_TypeSupportInterface () {};
            private:
                UpdateGeographicMap_Response_TypeSupportInterface (const UpdateGeographicMap_Response_TypeSupportInterface &);
                UpdateGeographicMap_Response_TypeSupportInterface & operator = (const UpdateGeographicMap_Response_TypeSupportInterface &);
            };

            class  UpdateGeographicMap_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UpdateGeographicMap_Response_DataWriter_ptr _ptr_type;
                typedef UpdateGeographicMap_Response_DataWriter_var _var_type;

                static UpdateGeographicMap_Response_DataWriter_ptr _duplicate (UpdateGeographicMap_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateGeographicMap_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateGeographicMap_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UpdateGeographicMap_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UpdateGeographicMap_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UpdateGeographicMap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UpdateGeographicMap_Response_& instance_data) = 0;

            protected:
                UpdateGeographicMap_Response_DataWriter () {};
                ~UpdateGeographicMap_Response_DataWriter () {};
            private:
                UpdateGeographicMap_Response_DataWriter (const UpdateGeographicMap_Response_DataWriter &);
                UpdateGeographicMap_Response_DataWriter & operator = (const UpdateGeographicMap_Response_DataWriter &);
            };

            class  UpdateGeographicMap_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UpdateGeographicMap_Response_DataReader_ptr _ptr_type;
                typedef UpdateGeographicMap_Response_DataReader_var _var_type;

                static UpdateGeographicMap_Response_DataReader_ptr _duplicate (UpdateGeographicMap_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateGeographicMap_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateGeographicMap_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UpdateGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UpdateGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UpdateGeographicMap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UpdateGeographicMap_Response_& instance) = 0;

            protected:
                UpdateGeographicMap_Response_DataReader () {};
                ~UpdateGeographicMap_Response_DataReader () {};
            private:
                UpdateGeographicMap_Response_DataReader (const UpdateGeographicMap_Response_DataReader &);
                UpdateGeographicMap_Response_DataReader & operator = (const UpdateGeographicMap_Response_DataReader &);
            };

            class  UpdateGeographicMap_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UpdateGeographicMap_Response_DataReaderView_ptr _ptr_type;
                typedef UpdateGeographicMap_Response_DataReaderView_var _var_type;

                static UpdateGeographicMap_Response_DataReaderView_ptr _duplicate (UpdateGeographicMap_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateGeographicMap_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateGeographicMap_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateGeographicMap_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UpdateGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UpdateGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UpdateGeographicMap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UpdateGeographicMap_Response_& instance) = 0;

            protected:
                UpdateGeographicMap_Response_DataReaderView () {};
                ~UpdateGeographicMap_Response_DataReaderView () {};
            private:
                UpdateGeographicMap_Response_DataReaderView (const UpdateGeographicMap_Response_DataReaderView &);
                UpdateGeographicMap_Response_DataReaderView & operator = (const UpdateGeographicMap_Response_DataReaderView &);
            };
            class Sample_UpdateGeographicMap_Request_TypeSupportInterface;

            typedef Sample_UpdateGeographicMap_Request_TypeSupportInterface * Sample_UpdateGeographicMap_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateGeographicMap_Request_TypeSupportInterface> Sample_UpdateGeographicMap_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateGeographicMap_Request_TypeSupportInterface> Sample_UpdateGeographicMap_Request_TypeSupportInterface_out;


            class Sample_UpdateGeographicMap_Request_DataWriter;

            typedef Sample_UpdateGeographicMap_Request_DataWriter * Sample_UpdateGeographicMap_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateGeographicMap_Request_DataWriter> Sample_UpdateGeographicMap_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateGeographicMap_Request_DataWriter> Sample_UpdateGeographicMap_Request_DataWriter_out;


            class Sample_UpdateGeographicMap_Request_DataReader;

            typedef Sample_UpdateGeographicMap_Request_DataReader * Sample_UpdateGeographicMap_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateGeographicMap_Request_DataReader> Sample_UpdateGeographicMap_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateGeographicMap_Request_DataReader> Sample_UpdateGeographicMap_Request_DataReader_out;


            class Sample_UpdateGeographicMap_Request_DataReaderView;

            typedef Sample_UpdateGeographicMap_Request_DataReaderView * Sample_UpdateGeographicMap_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateGeographicMap_Request_DataReaderView> Sample_UpdateGeographicMap_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateGeographicMap_Request_DataReaderView> Sample_UpdateGeographicMap_Request_DataReaderView_out;

            struct Sample_UpdateGeographicMap_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_UpdateGeographicMap_Request_, struct Sample_UpdateGeographicMap_Request_Seq_uniq_> Sample_UpdateGeographicMap_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_UpdateGeographicMap_Request_Seq> Sample_UpdateGeographicMap_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_UpdateGeographicMap_Request_Seq> Sample_UpdateGeographicMap_Request_Seq_out;

            class  Sample_UpdateGeographicMap_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_UpdateGeographicMap_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_UpdateGeographicMap_Request_TypeSupportInterface_var _var_type;

                static Sample_UpdateGeographicMap_Request_TypeSupportInterface_ptr _duplicate (Sample_UpdateGeographicMap_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateGeographicMap_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateGeographicMap_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_UpdateGeographicMap_Request_TypeSupportInterface () {};
                ~Sample_UpdateGeographicMap_Request_TypeSupportInterface () {};
            private:
                Sample_UpdateGeographicMap_Request_TypeSupportInterface (const Sample_UpdateGeographicMap_Request_TypeSupportInterface &);
                Sample_UpdateGeographicMap_Request_TypeSupportInterface & operator = (const Sample_UpdateGeographicMap_Request_TypeSupportInterface &);
            };

            class  Sample_UpdateGeographicMap_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_UpdateGeographicMap_Request_DataWriter_ptr _ptr_type;
                typedef Sample_UpdateGeographicMap_Request_DataWriter_var _var_type;

                static Sample_UpdateGeographicMap_Request_DataWriter_ptr _duplicate (Sample_UpdateGeographicMap_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateGeographicMap_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateGeographicMap_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_UpdateGeographicMap_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_UpdateGeographicMap_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_UpdateGeographicMap_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_UpdateGeographicMap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UpdateGeographicMap_Request_& instance_data) = 0;

            protected:
                Sample_UpdateGeographicMap_Request_DataWriter () {};
                ~Sample_UpdateGeographicMap_Request_DataWriter () {};
            private:
                Sample_UpdateGeographicMap_Request_DataWriter (const Sample_UpdateGeographicMap_Request_DataWriter &);
                Sample_UpdateGeographicMap_Request_DataWriter & operator = (const Sample_UpdateGeographicMap_Request_DataWriter &);
            };

            class  Sample_UpdateGeographicMap_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_UpdateGeographicMap_Request_DataReader_ptr _ptr_type;
                typedef Sample_UpdateGeographicMap_Request_DataReader_var _var_type;

                static Sample_UpdateGeographicMap_Request_DataReader_ptr _duplicate (Sample_UpdateGeographicMap_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateGeographicMap_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateGeographicMap_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UpdateGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UpdateGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UpdateGeographicMap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UpdateGeographicMap_Request_& instance) = 0;

            protected:
                Sample_UpdateGeographicMap_Request_DataReader () {};
                ~Sample_UpdateGeographicMap_Request_DataReader () {};
            private:
                Sample_UpdateGeographicMap_Request_DataReader (const Sample_UpdateGeographicMap_Request_DataReader &);
                Sample_UpdateGeographicMap_Request_DataReader & operator = (const Sample_UpdateGeographicMap_Request_DataReader &);
            };

            class  Sample_UpdateGeographicMap_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_UpdateGeographicMap_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_UpdateGeographicMap_Request_DataReaderView_var _var_type;

                static Sample_UpdateGeographicMap_Request_DataReaderView_ptr _duplicate (Sample_UpdateGeographicMap_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateGeographicMap_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateGeographicMap_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UpdateGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UpdateGeographicMap_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UpdateGeographicMap_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UpdateGeographicMap_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UpdateGeographicMap_Request_& instance) = 0;

            protected:
                Sample_UpdateGeographicMap_Request_DataReaderView () {};
                ~Sample_UpdateGeographicMap_Request_DataReaderView () {};
            private:
                Sample_UpdateGeographicMap_Request_DataReaderView (const Sample_UpdateGeographicMap_Request_DataReaderView &);
                Sample_UpdateGeographicMap_Request_DataReaderView & operator = (const Sample_UpdateGeographicMap_Request_DataReaderView &);
            };
            class Sample_UpdateGeographicMap_Response_TypeSupportInterface;

            typedef Sample_UpdateGeographicMap_Response_TypeSupportInterface * Sample_UpdateGeographicMap_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateGeographicMap_Response_TypeSupportInterface> Sample_UpdateGeographicMap_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateGeographicMap_Response_TypeSupportInterface> Sample_UpdateGeographicMap_Response_TypeSupportInterface_out;


            class Sample_UpdateGeographicMap_Response_DataWriter;

            typedef Sample_UpdateGeographicMap_Response_DataWriter * Sample_UpdateGeographicMap_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateGeographicMap_Response_DataWriter> Sample_UpdateGeographicMap_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateGeographicMap_Response_DataWriter> Sample_UpdateGeographicMap_Response_DataWriter_out;


            class Sample_UpdateGeographicMap_Response_DataReader;

            typedef Sample_UpdateGeographicMap_Response_DataReader * Sample_UpdateGeographicMap_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateGeographicMap_Response_DataReader> Sample_UpdateGeographicMap_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateGeographicMap_Response_DataReader> Sample_UpdateGeographicMap_Response_DataReader_out;


            class Sample_UpdateGeographicMap_Response_DataReaderView;

            typedef Sample_UpdateGeographicMap_Response_DataReaderView * Sample_UpdateGeographicMap_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateGeographicMap_Response_DataReaderView> Sample_UpdateGeographicMap_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateGeographicMap_Response_DataReaderView> Sample_UpdateGeographicMap_Response_DataReaderView_out;

            struct Sample_UpdateGeographicMap_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_UpdateGeographicMap_Response_, struct Sample_UpdateGeographicMap_Response_Seq_uniq_> Sample_UpdateGeographicMap_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_UpdateGeographicMap_Response_Seq> Sample_UpdateGeographicMap_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_UpdateGeographicMap_Response_Seq> Sample_UpdateGeographicMap_Response_Seq_out;

            class  Sample_UpdateGeographicMap_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_UpdateGeographicMap_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_UpdateGeographicMap_Response_TypeSupportInterface_var _var_type;

                static Sample_UpdateGeographicMap_Response_TypeSupportInterface_ptr _duplicate (Sample_UpdateGeographicMap_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateGeographicMap_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateGeographicMap_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_UpdateGeographicMap_Response_TypeSupportInterface () {};
                ~Sample_UpdateGeographicMap_Response_TypeSupportInterface () {};
            private:
                Sample_UpdateGeographicMap_Response_TypeSupportInterface (const Sample_UpdateGeographicMap_Response_TypeSupportInterface &);
                Sample_UpdateGeographicMap_Response_TypeSupportInterface & operator = (const Sample_UpdateGeographicMap_Response_TypeSupportInterface &);
            };

            class  Sample_UpdateGeographicMap_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_UpdateGeographicMap_Response_DataWriter_ptr _ptr_type;
                typedef Sample_UpdateGeographicMap_Response_DataWriter_var _var_type;

                static Sample_UpdateGeographicMap_Response_DataWriter_ptr _duplicate (Sample_UpdateGeographicMap_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateGeographicMap_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateGeographicMap_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_UpdateGeographicMap_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_UpdateGeographicMap_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_UpdateGeographicMap_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_UpdateGeographicMap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UpdateGeographicMap_Response_& instance_data) = 0;

            protected:
                Sample_UpdateGeographicMap_Response_DataWriter () {};
                ~Sample_UpdateGeographicMap_Response_DataWriter () {};
            private:
                Sample_UpdateGeographicMap_Response_DataWriter (const Sample_UpdateGeographicMap_Response_DataWriter &);
                Sample_UpdateGeographicMap_Response_DataWriter & operator = (const Sample_UpdateGeographicMap_Response_DataWriter &);
            };

            class  Sample_UpdateGeographicMap_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_UpdateGeographicMap_Response_DataReader_ptr _ptr_type;
                typedef Sample_UpdateGeographicMap_Response_DataReader_var _var_type;

                static Sample_UpdateGeographicMap_Response_DataReader_ptr _duplicate (Sample_UpdateGeographicMap_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateGeographicMap_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateGeographicMap_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UpdateGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UpdateGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UpdateGeographicMap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UpdateGeographicMap_Response_& instance) = 0;

            protected:
                Sample_UpdateGeographicMap_Response_DataReader () {};
                ~Sample_UpdateGeographicMap_Response_DataReader () {};
            private:
                Sample_UpdateGeographicMap_Response_DataReader (const Sample_UpdateGeographicMap_Response_DataReader &);
                Sample_UpdateGeographicMap_Response_DataReader & operator = (const Sample_UpdateGeographicMap_Response_DataReader &);
            };

            class  Sample_UpdateGeographicMap_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_UpdateGeographicMap_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_UpdateGeographicMap_Response_DataReaderView_var _var_type;

                static Sample_UpdateGeographicMap_Response_DataReaderView_ptr _duplicate (Sample_UpdateGeographicMap_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateGeographicMap_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateGeographicMap_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateGeographicMap_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UpdateGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UpdateGeographicMap_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UpdateGeographicMap_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UpdateGeographicMap_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UpdateGeographicMap_Response_& instance) = 0;

            protected:
                Sample_UpdateGeographicMap_Response_DataReaderView () {};
                ~Sample_UpdateGeographicMap_Response_DataReaderView () {};
            private:
                Sample_UpdateGeographicMap_Response_DataReaderView (const Sample_UpdateGeographicMap_Response_DataReaderView &);
                Sample_UpdateGeographicMap_Response_DataReaderView & operator = (const Sample_UpdateGeographicMap_Response_DataReaderView &);
            };
        }

    }

}

#endif
